<?php
namespace BMSIplugin;

class BMSIActivate
{
    public function __construct()
    {
    }

    public static function bmsi_activate()
    {
        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();

        $tables = [
            'tbl_mail_details' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_mail_details (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                `from_mail` varchar(255) NOT NULL,
                `from_name` varchar(255) NOT NULL,
                `subject` varchar(255) NOT NULL,
                `body` LONGTEXT NOT NULL,
                `createdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                PRIMARY KEY (`id`)
            ) $charset_collate",


            'tbl_all_mail' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_all_mail (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                `from_mail` varchar(255) NOT NULL,
                `to_mail` varchar(255) NOT NULL,
                `email_send_id` varchar(255) NOT NULL,
                `from_name` varchar(255) NULL,
                `subject` varchar(255) NOT NULL,
                `category` varchar(255) NULL,
                `status` varchar(255) NULL,
                `createdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                PRIMARY KEY (`id`)
            ) $charset_collate",

            'tbl_all_mail_detail' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_all_mail_detail (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                `body` LONGTEXT NOT NULL,
                `createdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                PRIMARY KEY (`id`)
            ) $charset_collate",

            'tbl_total_mail' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_total_mail (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                `total` int(25) NOT NULL,
                `newsletter` int(25) NOT NULL,
                `user` int(25) NOT NULL,
                `createdate` date NOT NULL,
                PRIMARY KEY (`id`)
            ) $charset_collate",

            'tbl_send_mail_details' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_send_mail_details (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                `mail_detail_id` varchar(255) NOT NULL,
                `user_id` varchar(255) NOT NULL,
                `createdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                PRIMARY KEY (`id`)
            ) $charset_collate",

            'tbl_news_letters' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_news_letters (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                `from_mail` varchar(255) NOT NULL,
                `from_name` varchar(255) NOT NULL,
                `subject` varchar(255) NOT NULL,
                `body` LONGTEXT NOT NULL,
                `type` varchar(5000) NOT NULL,
                `createdate` date NOT NULL,
                PRIMARY KEY (`id`)
            ) $charset_collate",

            'tbl_history' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_history (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                `from_name` varchar(255) NOT NULL,
                `subject` varchar(255) NOT NULL,
                `body` LONGTEXT NOT NULL,
                `type` varchar(255) NOT NULL,
                `createdate` date NOT NULL,
                PRIMARY KEY (`id`)
            ) $charset_collate",

            'tbl_email_queue' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_email_queue (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                to_email VARCHAR(100) NOT NULL,
                subject VARCHAR(255) NOT NULL,
                message LONGTEXT NOT NULL,
                headers TEXT NOT NULL,
                PRIMARY KEY (`id`)
            ) $charset_collate",

            'tbl_diegn_template' => "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}bmsi_design_template (
                `id` int(25) NOT NULL AUTO_INCREMENT,
                message LONGTEXT NOT NULL,
                PRIMARY KEY (`id`)
            ) $charset_collate",
        ];

        require_once ABSPATH . 'wp-admin/includes/upgrade.php';

        foreach ($tables as $table_name => $create_statement) {
            maybe_create_table($wpdb->prefix . $table_name, $create_statement);
        }



       

    
    }


    
    
    
    

    
}

?>
