<?php

namespace BMSIplugin;



use BMSIplugin\BMSIEmailQueue;

use PHPMailer\PHPMailer\PHPMailer;

use PHPMailer\PHPMailer\Exception;



class BMSIAdmin

{

    public function __construct()

    {

        add_action('admin_enqueue_scripts', [$this, 'bmsi_admin_enqueue_scripts']);

        add_action('admin_menu', [$this, 'bmsi_admin_page']);

        add_action('wp_ajax_BMSI_display_users', [$this, "BMSI_get_users_callback"]);

        add_action('wp_ajax_nopriv_BMSI_display_users', [$this, "BMSI_get_users_callback"]);

        add_action('wp_ajax_BMSI_User_send_mail_template', [$this, "BMSI_User_send_mail_template_callback"]);

        add_action('wp_ajax_nopriv_BMSI_User_send_mail_template', [$this, "BMSI_User_send_mail_template_callback"]);

        add_action('wp_ajax_BMSI_manage_setting', [$this, "BMSI_manage_setting_callback"]);

        add_action('wp_ajax_nopriv_BMSI_manage_setting', [$this, "BMSI_manage_setting_callback"]);

        add_action('wp_ajax_BMSI_create_new_user', [$this, "BMSI_create_new_user_callback"]);

        add_action('wp_ajax_nopriv_BMSI_create_new_user', [$this, "BMSI_create_new_user_callback"]);

        add_action('wp_ajax_BMSI_User_send_mail', [$this, "BMSI_User_send_mail_callback"]);

        add_action('wp_ajax_nopriv_BMSI_User_send_mail', [$this, "BMSI_User_send_mail_callback"]);

        add_action('wp_ajax_BMSI_view_user', [$this, "BMSI_view_user_callback"]);

        add_action('wp_ajax_nopriv_BMSI_view_user', [$this, "BMSI_view_user_callback"]);

        add_action('wp_ajax_BMSI_delete_user', [$this, "BMSI_delete_users_callback"]);

        add_action('wp_ajax_nopriv_BMSI_delete_user', [$this, "BMSI_delete_users_callback"]);

        add_action('wp_ajax_BMSI_User_send_mail_template_newsletter', [$this, "BMSI_User_send_mail_template_newsletter_callback"]);

        add_action('wp_ajax_nopriv_BMSI_User_send_mail_template_newsletter', [$this, "BMSI_User_send_mail_template_newsletter_callback"]);

        add_action('wp_ajax_BMSI_User_send_mail_manual_news_letter', [$this, "BMSI_User_send_mail_manual_news_letter_callback"]);

        add_action('wp_ajax_nopriv_BMSI_User_send_mail_manual_news_letter', [$this, "BMSI_User_send_mail_manual_news_letter_callback"]);

        add_action('wp_ajax_BMSI_pro_User_send_mail', [$this, "BMSI_pro_User_send_mail_callback"]);

        add_action('wp_ajax_nopriv_BMSI_pro_User_send_mail', [$this, "BMSI_pro_User_send_mail_callback"]);

        add_action('admin_init', [$this, 'BMSI_register_settings']);

        add_action('wp_ajax_BMSI_display_history', [$this, "BMSI_display_history_callback"]);

        add_action('wp_ajax_nopriv_BMSI_display_history', [$this, "BMSI_display_history_callback"]);

        add_action('wp_ajax_BMSI_view_history', [$this, "BMSI_view_history_callback"]);

        add_action('wp_ajax_nopriv_BMSI_view_history', [$this, "BMSI_view_history_callback"]);

        add_action('wp_ajax_BMSI_SMTP_Connect', [$this, "BMSI_SMTP_Connect_callback"]);

        add_action('wp_ajax_BMSI_per_hour_send_mail', [$this, "BMSI_per_hour_send_mail_callback"]);

        add_action('wp_ajax_nopriv_BMSI_SMTP_Connect', [$this, "BMSI_SMTP_Connect_callback"]);

        add_action('wp_ajax_save_email_template', [$this, "save_email_template_callback"]);

        add_action('wp_ajax_nopriv_save_email_template', [$this, "save_email_template_callback"]);

        add_action('wp_ajax_get_saved_email_template', [$this, "get_saved_email_template_callback"]);

        add_action('wp_ajax_nopriv_get_saved_email_template', [$this, "get_saved_email_template_callback"]);

        add_action('wp_ajax_get_category', [$this, "get_category_callback"]);

        add_action('wp_ajax_nopriv_get_category', [$this, "get_category_callback"]);

        add_action('wp_ajax_get_user_from_email', [$this, "get_user_from_email_callback"]);

        add_action('wp_ajax_nopriv_get_user_from_email', [$this, "get_user_from_email_callback"]);

        add_action('wp_ajax_BMSI_templat_email_body', [$this, "BMSI_templat_email_body_callback"]);

        add_action('wp_ajax_nopriv_BMSI_templat_email_body', [$this, "BMSI_templat_email_body_callback"]);

        add_action('wp_ajax_update_email_template', [$this, "update_email_template_callback"]);

        add_action('wp_ajax_nopriv_update_email_template', [$this, "update_email_template_callback"]);

        add_action('phpmailer_init', [$this, 'configure_phpmailer_callback']);





     



        add_action('admin_head', function () {

            remove_submenu_page('bulk_mail_sender', 'bulk_mail_sender');

            remove_submenu_page('bulk_mail_sender', 'users');

            remove_submenu_page('bulk_mail_sender', 'create_user');

            remove_submenu_page('bulk_mail_sender', 'send_mail');

            remove_submenu_page('bulk_mail_sender', 'templates');

            remove_submenu_page('bulk_mail_sender', 'newsletter');

            remove_submenu_page('bulk_mail_sender', 'history');

            remove_submenu_page('bulk_mail_sender', 'settings');

            remove_submenu_page('bulk_mail_sender', 'newsletter_category');

            remove_submenu_page('bulk_mail_sender', 'newsletter_tags');

            remove_submenu_page('bulk_mail_sender', 'newsletter_add_user');

            remove_submenu_page('bulk_mail_sender', 'get_help');

            remove_submenu_page('bulk_mail_sender', 'email_builder');

        });



        if (!wp_next_scheduled('send_scheduled_emails_hook')) {

            wp_schedule_event(time(), 'hourly', 'send_scheduled_emails_hook');

        }



        add_action('send_scheduled_emails_hook', [$this,'send_scheduled_emails']);

        

        add_shortcode( 'user_unsubscribed', [$this,'bmsi_init'] );



    }

    

    public function bmsi_init(){

        global $wpdb;

        $message = "";

        if($_GET['is_unsubscribed']){

            $table = $wpdb->prefix . 'bmsi_news_letters_email';

            $get_id = $_GET['is_unsubscribed'];

            $query = "SELECT * FROM {$wpdb->prefix}bmsi_news_letters_email Where id = $get_id";

            $get_data = $wpdb->get_row($query);

            if ( $get_data ) {

                $id = $get_data->id;

                $wpdb->update( $table, ['status' => 0], ['id' => $id] );

                $message = 'You have successfully unsubscribed';

            } else {

                $message = 'Sorry, we could not find your subscription details.';

            }

        }else{

            $message = 'The URL is incorrect or missing the required parameter.';

        }

        return '<h1>' . esc_html($message) . '</h1>';

    }

    

    public function send_scheduled_emails() {

     

        global $wpdb;



        $log_file = BMSI_DIR_PATH . '/cron-log.txt';



        $emails_per_hour = get_option('BMSI_per_hour_send_mail'); 

        $option = get_option("BMSI_SMTP_Options");

        $user_option = get_option("BMSI_User_Options");



        if(!empty($emails_per_hour)){

            $emails_query = $wpdb->prepare(

                "SELECT * FROM {$wpdb->prefix}bmsi_all_mail LIMIT %d",

                $emails_per_hour

            );

        }else{

            $emails_query = $wpdb->prepare(

                "SELECT * FROM {$wpdb->prefix}bmsi_all_mail",

            );

        }

        

       

        $emails = $wpdb->get_results($emails_query);



        if (empty($emails)) {

            return; 

        }

    

        $failed_emails = [];

        foreach ($emails as $email) {

         

            $details_query = $wpdb->prepare(

                "SELECT * FROM {$wpdb->prefix}bmsi_all_mail_detail WHERE id = %d",

                $email->email_send_id

            );

            $details = $wpdb->get_row($details_query);



            $from_mail = $email->from_mail;

            $to = $email->to_mail; 

            $subject = $email->subject; 

            $message = $details->body;

            $headers = array('Content-Type: text/html; charset=UTF-8');



            $user = get_user_by( 'email', $to );

            $userId = $user->ID;

            $new_user = get_userdata($userId);



            $first_name = $new_user->first_name;

            $last_name = $new_user->last_name;

            

            $news_latter_query =  $wpdb->prepare(

                "SELECT * FROM {$wpdb->prefix}bmsi_news_letters_email WHERE email = %s",

                $to

            );

            $detail_unsunscribed = $wpdb->get_row($news_latter_query);

            $unsubscribed_id = $detail_unsunscribed->id;
            $f_name = $detail_unsunscribed->fname;
            $l_name = $detail_unsunscribed->lname;

          

          $get_url = get_site_url() . '/unsubscribe?is_unsubscribed=' . $unsubscribed_id;

          

            $message = str_replace('[user_name]', $f_name . ' ' . $l_name, $message);

            

            $message = str_replace('[unsubscribed]', "<a style='color:#000; text-decoration:none;' href='".$get_url."'>Unsubscribe</a>", $message);

            

            if($user_option['smtp_connect'] == "true"){

                if(!empty($option)){

                    try {

                        global $phpmailer;



                        if (!($phpmailer instanceof PHPMailer)) {

                            require_once ABSPATH . WPINC . '/PHPMailer/PHPMailer.php';

                            require_once ABSPATH . WPINC . '/PHPMailer/SMTP.php';

                            require_once ABSPATH . WPINC . '/PHPMailer/Exception.php';

                        }

            

                        $phpmailer = new PHPMailer(true);

        

                        $phpmailer->isSMTP();

                        $phpmailer->Host = $option["smtpH"] ?? '';

        

                        

                        

                        $phpmailer->SMTPAuth = true;

                        $phpmailer->Port = $option["smtpPort"] ?? 587;

                        $phpmailer->Username = $option["smtpU"] ?? '';

                        $phpmailer->Password = $option["smtpPass"] ?? '';

                        $phpmailer->SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS; 

                        if (!empty($option["Secure"]) && strtolower($option["Secure"]) === "ssl") {

                            $phpmailer->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;

                            $phpmailer->Port = 465;

                            $phpmailer->SMTPAutoTLS = false; 

                        } else {

                            $phpmailer->SMTPAutoTLS = true; 

                        }

        

                        $phpmailer->isHTML(true);

                        

                        

                        $phpmailer->setFrom($from_mail);

                        $phpmailer->addAddress($to, 'receiver');    

                        $phpmailer->Subject = $subject;

                        $phpmailer->Body    = $message;

        

                        

                        if ($phpmailer->send()) {

                        

                            $wpdb->delete(

                                "{$wpdb->prefix}bmsi_all_mail",

                                array('id' => $email->id)

                            );



                        }

                    } catch (Exception $e) {

                        file_put_contents($log_file, "SMTP Error: {$e->getMessage()}\n", FILE_APPEND);

                    }

                }

               

            }else{

                $mail_sent = wp_mail($to, $subject, $message, $headers);

                if ($mail_sent) {

                    $wpdb->delete(

                        "{$wpdb->prefix}bmsi_all_mail",

                        array('id' => $email->id)

                    );

                }else {

                    file_put_contents($log_file, "Failed to send email using wp_mail to: $to\n", FILE_APPEND);

                    $failed_emails[] = $to;

                }

            }

          

            

           

           

        }



        $failed_emails_string = $failed_emails ? implode(', ', $failed_emails) : "";

        $current_date_time = date('Y-m-d h:i:s A');

        wp_mail(

            'dipakravalwork445@gmail.com',

            'Mail send successfully',

            'Failed emails: ' . $failed_emails_string . "\n\n",

            'Current date and time: ' . $current_date_time

        );

         

    }



    public function bmsi_admin_enqueue_scripts()

    {

        global $pagenow;

        if ($pagenow == "admin.php") {

            if (in_array($_GET['page'], ["users", "email_builder", "create_user", "send_mail", "history", "newsletter", "newsletter_category", "newsletter_tags", "get_help", "bulk_mail_sender", "settings", "templates", "create_template"])) {

                wp_enqueue_style('bms-admin-css', BMSI_DIR_URI . 'assets/css/admin_style.css', '1.1.3');

                wp_enqueue_style('datatables-style', BMSI_DIR_URI . 'assets/css/jquery.dataTables.min.css', '1.1.3');

                wp_enqueue_style('btn-css', BMSI_DIR_URI . 'assets/css/buttons.dataTables.min.css', '1.1.3');

                wp_enqueue_style('filter_toggle', BMSI_DIR_URI . 'assets/css/bootstrap.min.css', '1.1.3');

                wp_enqueue_style('font_awosme_icon', BMSI_DIR_URI . 'assets/css/all.min.css', '1.1.3');

                wp_enqueue_style('chart_style', BMSI_DIR_URI . 'assets/css/apexcharts.min.css', '1.1.3');

                wp_enqueue_style('jquery-confirm', BMSI_DIR_URI . 'assets/css/apexcharts.min.css', '1.1.3');

                wp_enqueue_style('alert-css', BMSI_DIR_URI . 'assets/css/alert_style.css', '1.1.3');

                wp_enqueue_style('jquery-te-1.4.0-css', BMSI_DIR_URI . 'assets/css/jquery-te-1.4.0.css', '1.4.0');

                wp_enqueue_script('chart_script', BMSI_DIR_URI . 'assets/js/apexcharts.min.js');

                wp_enqueue_script('sortable-js', BMSI_DIR_URI . 'assets/js/sortable.js');

                wp_enqueue_script('alert-js', BMSI_DIR_URI . 'assets/js/alert_script.js');

                wp_enqueue_script('Tq-js', BMSI_DIR_URI . 'assets/js/jquery-te-1.4.0.min.js');

                wp_enqueue_script('chart-js', BMSI_DIR_URI . 'assets/js/chart.js', '4.4.2');

                wp_enqueue_script('angular-js', 'https://cdnjs.cloudflare.com/ajax/libs/angular.js/1.8.3/angular.min.js', '1.8.3');

                wp_enqueue_script('ajax-model-script', BMSI_DIR_URI . 'assets/js/jquery.modal.min.js');

                wp_enqueue_script('filter_toggle_script', BMSI_DIR_URI . 'assets/js/popper.min.js');

                wp_enqueue_script('filter_toggle_script_', BMSI_DIR_URI . 'assets/js/bootstrap.min.js');

                wp_enqueue_script('filter_toggle_script_', BMSI_DIR_URI . 'assets/js/bootstrap.min.js');

                wp_enqueue_script('validate_data', BMSI_DIR_URI . 'assets/js/jquery.validate.min.js');

                wp_enqueue_script('datatables-script', BMSI_DIR_URI . 'assets/js/jquery.dataTables.min.js', array('jquery'), '1.10.25', true);

                wp_enqueue_script('btn-js', BMSI_DIR_URI . 'assets/js/dataTables.buttons.min.js', array('datatables'), '1.7.1', true);

                wp_enqueue_script('bmsi_admin_js', BMSI_DIR_URI . 'assets/js/admin_script.js', ['jquery'], '1.1.3', true);

                wp_enqueue_script('bulk-mail-sender-app', BMSI_DIR_URI . 'assets/js/app.min.js', ['vue'], '1.0', true);

                wp_enqueue_script('vue', 'https://cdn.jsdelivr.net/npm/vue@3.4.29/dist/vue.global.prod.js', [], null, true);

                wp_enqueue_media();

                wp_localize_script(

                    'bmsi_admin_js',

                    'BMSI_object',

                    array(

                        'ajax_url' => esc_url(admin_url('admin-ajax.php')),

                        'plugin_url' => BMSI_DIR_URI,

                        'admin_url' => esc_url(get_admin_url()),

                        'nonce' => wp_create_nonce('ajax-nonce'),

                        'BMSI_Option' => get_option("BMSI_User_Options"),

                    )

                );

            }

            if (in_array($_GET['page'], ["send_mail"])) {

                wp_enqueue_script('radio-js', BMSI_DIR_URI . 'assets/js/radio.js');

            }

            if (in_array($_GET['page'], ["history"])) {

                wp_enqueue_style('history-css', BMSI_DIR_URI . 'assets/css/history.css');

            }

            if (in_array($_GET['page'], ["settings"])) {

                wp_enqueue_script('settings-js', BMSI_DIR_URI . 'assets/js/setting.js');

            }

            if (in_array($_GET['page'], ["send_mail"])) {

                wp_enqueue_script('preview-js', BMSI_DIR_URI . 'assets/js/preview.js');

            }

        }

    }

    public function bmsi_admin_page()

    {

        add_menu_page(

            __('Bulk Mail Sender', 'bulk-mail'),

            __('Bulk Mail Sender', 'bulk-mail'),

            'manage_options',

            'email_builder',

            [$this, 'BMSI_email_builder_callback'],

            BMSI_DIR_URI . 'assets/images/icon.svg',

            6

        );



        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Users', 'bulk-mail'),

            __('Users', 'bulk-mail'),

            'manage_options',

            'users',

            [$this, 'bmsi_admin_users_submenu_page'],

        );





        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Add Users', 'bulk-mail'),

            __('Create User', 'bulk-mail'),

            'manage_options',

            'create_user',

            [$this, 'bmsi_admin_create_user_submenu_page'],

        );

        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Send Mail', 'bulk-mail'),

            __('Send Mail', 'bulk-mail'),

            'manage_options',

            'send_mail',

            [$this, 'BMSI_send_mail_callback'],

        );

        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Send Mail', 'bulk-mail'),

            __('Templates', 'bulk-mail'),

            'manage_options',

            'templates',

            [$this, 'BMSI_templates_callback'],

        );

        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Send Mail', 'bulk-mail'),

            __('Contacts', 'bulk-mail'),

            'manage_options',

            'newsletter',

            [$this, 'BMSI_newsletter_callback'],

        );

        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Send Mail', 'bulk-mail'),

            __('Contacts Category', 'bulk-mail'),

            'manage_options',

            'newsletter_category',

            [$this, 'BMSI_newsletter_category_callback'],

        );



        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Send Mail', 'bulk-mail'),

            __('Contacts Tags', 'bulk-mail'),

            'manage_options',

            'newsletter_tags',

            [$this, 'BMSI_newsletter_tags_callback'],

        );



        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Send Mail', 'bulk-mail'),

            __('Contacts Add User', 'bulk-mail'),

            'manage_options',

            'newsletter_add_user',

            [$this, 'BMSI_newsletter_add_user_callback'],

        );



        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Send Mail', 'bulk-mail'),

            __('History', 'bulk-mail'),

            'manage_options',

            'history',

            [$this, 'BMSI_History_callback'],

        );



        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Setting', 'bulk-mail'),

            __('Setting', 'bulk-mail'),

            'manage_options',

            'settings',

            [$this, 'BMSI_setting_callback'],

        );



        add_submenu_page(

            'bulk_mail_sender',

            __('Bulk Mail Sender Get Help', 'bulk-mail'),

            __('Get Help', 'bulk-mail'),

            'manage_options',

            'get_help',

            [$this, 'BMSI_get_help_callback'],

        );



    }

    public function bmsi_main_admin_page()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSIDashboard.php');

    }



    public function BMSI_templates_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSITemplate.php');

    }



    public function bmsi_admin_users_submenu_page()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSIUser.php');

    }



    public function BMSI_setting_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSISetting.php');

    }



    public function bmsi_admin_create_user_submenu_page()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSIAddUser.php');

    }



    public function BMSI_send_mail_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSISendMail.php');

    }



    public function BMSI_newsletter_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSINewsLetters.php');

    }



    public function BMSI_newsletter_category_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSInewslettercategory.php');

    }



    public function BMSI_newsletter_tags_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSInewsletterTags.php');

    }



    public function BMSI_newsletter_add_user_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSInewslettercategory.php');

    }



    public function BMSI_History_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSIHistory.php');

    }



    public function BMSI_get_help_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSIGetHelp.php');

    }



    public function BMSI_email_builder_callback()

    {

        require_once (BMSI_DIR_PATH . 'templates/BMSIEmailBuilder.php');

    }



    public function BMSI_get_users_callback()

    {



        if (!isset($_POST['user_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['user_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;

        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;

        $search = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : "";

        $role = isset($_POST["role"]) ? sanitize_text_field($_POST["role"]) : "";



        if (!empty($role) && $role == "All") {

            $args = array(

                'search' => '*' . $search . '*',

                'orderby' => 'ID',

                'order' => 'ASC',

                'offset' => $start,

                'number' => $length,

            );

        } else {

            $args = array(

                'search' => '*' . $search . '*',

                'orderby' => 'ID',

                'order' => 'ASC',

                'offset' => $start,

                'number' => $length,

                'role' => $role,

            );

        }



        $users = get_users($args);





        $total_users_count = count_users();

        $total_users = $total_users_count['total_users'];



        $user_data = array();

        foreach ($users as $user) {

            $mobile_no = get_user_meta($user->ID, 'mobile', true);

            $user_role_name = get_role_from_slug(implode(',', $user->roles));

            $user_data[] = array(

                'id' => $user->ID,

                'uname' => $user->user_login,

                'email' => $user->user_email,

                'mobile_no' => $mobile_no,

                'role' => $user_role_name,

            );

        }



        $response = [

            'draw' => intval($_POST['draw']),

            'recordsTotal' => $total_users,

            'recordsFiltered' => $total_users,

            'data' => !empty($user_data) ? $user_data : "",

        ];



        echo wp_json_encode($response);

        wp_die();



    }



    public function BMSI_User_send_mail_callback()

    {

        if (!isset($_POST['send_mail_user_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['send_mail_user_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $option = get_option("BMSI_User_Options");



        global $wpdb;

        $tbl_mail_details = $wpdb->prefix . 'bmsi_mail_details';

        $tbl_send_mail_details = $wpdb->prefix . 'bmsi_send_mail_details';

        $table_total_mail = $wpdb->prefix . 'bmsi_total_mail';

        $table_history = $wpdb->prefix . 'bmsi_history';

        $total_mail_result_query = $wpdb->prepare("SELECT * FROM %1s", $table_total_mail);

        $total_mail_result = $wpdb->get_results($total_mail_result_query);

        $today_mail_result_query = $wpdb->prepare("SELECT * FROM %1s ORDER BY createdate DESC LIMIT 1", $table_total_mail);

        $today_mail_result = $wpdb->get_results($today_mail_result_query);

        $mail_counter = 0;

        $count = 0;



        $subject = !empty($_POST['subject']) ? sanitize_text_field($_POST['subject']) : "";

        $sender = !empty($_POST['sender']) ? sanitize_text_field($_POST['sender']) : "";

        $sender_mail = !empty($_POST['sender_email']) ? sanitize_text_field($_POST['sender_email']) : "";





        $all_users = get_users();

        $user_emails = array();

        $today_date = date('Y-m-d');



        foreach ($all_users as $user) {

            $user_emails[] = $user->user_email;

            $user_id = get_current_user_id();

        }



        foreach ($user_emails as $email) {



            $message = !empty($_POST['body']) ? wp_kses_post($_POST['body']) : " ";





            

            $details_data = [

                'from_mail' => $sender_mail,

                'from_name' => $sender,

                'subject' => $subject,

                'body' => $message,

            ];



            $history_details_data = [

                'from_name' => $sender,

                'subject' => $subject,

                'body' => $message,

                'type' => 'manual',

                'createdate' => $today_date

            ];



            if ($option["permission"] == "true") {

                $insert_detail_data = $wpdb->insert(

                    $tbl_mail_details,

                    $details_data,

                );



                $sender_id = $wpdb->insert_id;

            }





            $headers = array(

                'From: ' . $sender . ', <' . $sender_mail . '>',

                'Content-Type: text/html; charset=UTF-8'

            );





            $send_details_data = [

                'mail_detail_id' => !empty($sender_id) ? $sender_id : "",

                'user_id' => $user_id,

            ];



            if ($option["permission"] == "true") {

                $insert_sql = $wpdb->prepare("

            INSERT INTO $tbl_send_mail_details (`mail_detail_id`, `user_id`)

            VALUES (%s, %s)

            ", $send_details_data['mail_detail_id'], $send_details_data['user_id']);



                $wpdb->query($insert_sql);



            }



            if ($option["permission"] == "true") {

                $insert_detail = $wpdb->insert(

                    $table_history,

                    $history_details_data

                );

                $email_id = $wpdb->insert_id;



                if ($email_id) {

                    $tracking_pixel_url = plugins_url('track.php', __FILE__) . '?id=' . $email_id;

                    $tracking_pixel = '<img src="' . esc_url($tracking_pixel_url) . '" alt="track" width="1" height="1" border="0" />';

                    $message .= $tracking_pixel;

                }

            }





            if (isset($option["cron"]) && $option["cron"] == "true") {

                $email_queue = new BMSIEmailQueue;



                $result = $email_queue->add_to_email_queue($email, $subject, $message, $headers);

                $count++;

            } else {

                $result = wp_mail($email, $subject, $message, $headers);

                $count++;

            }



            if ($insert_detail !== false) {

                if ($result === false) {

                    $wpdb->delete(

                        $tbl_mail_details,

                        array('id' => $email_id)

                    );

                }

            }



            if ($insert_detail_data !== false && !empty($result)) {

                $mail_counter++;

            }





        }





        if (!empty($total_mail_result)) {

            if ($today_mail_result[0]->createdate === $today_date) {

                $total_news_mail = $today_mail_result[0]->newsleeter;

                $total_user_mail = $today_mail_result[0]->user + $mail_counter;

                $total_mail = $today_mail_result[0]->total + $mail_counter;

                $total_mail_details_data = array(

                    'total' => $total_mail,

                    'user' => $total_user_mail,

                    'newsleeter' => $total_news_mail

                );

                $where = array(

                    'createdate' => $today_date

                );

                $wpdb->update($table_total_mail, $total_mail_details_data, $where);

            } else {

                $total_mail_details_data = array(

                    'total' => $mail_counter,

                    'user' => $mail_counter,

                    'newsleeter' => 0,

                    'createdate' => $today_date

                );

                $wpdb->insert(

                    $table_total_mail,

                    $total_mail_details_data,

                );

            }

        } else {

            $total_mail_details_data = array(

                'total' => $mail_counter,

                'user' => $mail_counter,

                'newsleeter' => 0,

                'createdate' => $today_date

            );

            $wpdb->insert(

                $table_total_mail,

                $total_mail_details_data,

            );

        }







        if ($count > 0) {

            if ($result) {

                $message = "Mail Send Successfully";

                $title = "Well Done!";

                $response = [

                    'status' => true,

                    'message' => esc_html($message, 'bulk-mail'),

                    'title' => esc_html($title, 'bulk-mail'),

                ];

            } else {

                $message = "Mails Send Failed";

                $title = "Alert!";

                $response = [

                    'status' => false,

                    'message' => esc_html($message, 'bulk-mail'),

                    'title' => esc_html($title, 'bulk-mail'),

                ];

            }

        } else {

            $message = "No users are available";

            $title = "Alert!";



            $response = [

                'status' => false,

                'title' => esc_html($title, 'bulk-mail'),

                'message' => esc_html($message, 'bulk-mail'),

            ];

        }



        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();



    }



    public function BMSI_pro_User_send_mail_callback()

    {



        if (!isset($_POST['send_mail_user_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['send_mail_user_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }

    

        $today_date = date('Y-m-d');

        $option = get_option("BMSI_User_Options");



        global $wpdb;

        $table_all_mail = $wpdb->prefix . 'bmsi_all_mail';

        $table_all_detail = $wpdb->prefix . 'bmsi_all_mail_detail';

        $tbl_mail_details = $wpdb->prefix . 'bmsi_mail_details';

        $table_mail_details = $wpdb->prefix . 'bmsi_pro_send_mail_details';

        $table_total_mail = $wpdb->prefix . 'bmsi_total_mail';

        $table_history = $wpdb->prefix . 'bmsi_history';

        $mail_counter = 0;

        $count = 0;



        $subject = !empty($_POST['subject']) ? sanitize_text_field($_POST['subject']) : "";

        $sender = !empty($_POST['sender']) ? sanitize_text_field($_POST['sender']) : "";

        $sender_mail = !empty($_POST['sender_mail']) ? sanitize_text_field($_POST['sender_mail']) : "";

        $message = !empty($_POST['body']) ? stripslashes($_POST['body']) : " ";

      



        $all_users = get_users();

        $user_emails = array();



        foreach ($all_users as $user) {

            $user_emails[] = $user->user_email;

        }



        $result = false;



        $all_mail_detail = [

            'body' => $message,

        ];

        



        $insert_all_detail_deta = $wpdb->insert(

            $table_all_detail,

            $all_mail_detail

        );



        $insert_id = $wpdb->insert_id;



       

        foreach ($user_emails as $email) {





          

            $from_header = 'From: ' . $sender . ' <' . $sender_mail . '>';



            $all_mail = [

                'subject' => $subject,

                'from_name'=> $sender,

                'from_mail' => $sender_mail,

                'to_mail' => $email,

                'email_send_id' => $insert_id

            ];

            

          

            

            $insert_detail_data = $wpdb->insert(

                $table_all_mail,

                $all_mail

            );





        }

       

    



        if ($insert_detail_data) {

        

            $message = "Mail Saved Successfully";

            $title = "Well Done!";

            $response = [

                'status' => true,

                'message' => esc_html($message, 'bulk-mail'),

                'title' => esc_html($title, 'bulk-mail'),

            ];

           

        } else {

            $message = "No Users are available";

            $title = "Alert!";

            $response = [

                'status' => false,

                'message' => esc_html($message, 'bulk-mail'),

                'title' => esc_html($title, 'bulk-mail'),

            ];

        }



        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();

    }



    public function BMSI_manage_setting_callback()

    {



        if (is_bulk_mail_pro_activated() == "true") {

            if (get_option('BMIS_Pro_activated')) {

                $history_permission = !empty($_POST["checked"]) ? sanitize_text_field($_POST["checked"]) : "";

                $form_title = !empty($_POST["form_title"]) ? sanitize_text_field($_POST["form_title"]) : "";

                $sub_text = !empty($_POST["sub_text"]) ? sanitize_text_field($_POST["sub_text"]) : "";

                $role_permission = !empty($_POST["role_permission"]) ? sanitize_text_field($_POST["role_permission"]) : "";

                $connect_smtp = !empty($_POST["connect_smtp"]) ? sanitize_text_field($_POST["connect_smtp"]) : "";

                $use_cron_job = !empty($_POST["use_cron_job"]) ? sanitize_text_field($_POST["use_cron_job"]) : "";

                $auto_pass = !empty($_POST["auto_pass"]) ? sanitize_text_field($_POST["auto_pass"]) : "";

                $theme_color = !empty($_POST["theme_color"]) ? sanitize_text_field($_POST["theme_color"]) : "";



                $user_options['permission'] = $history_permission;

                $user_options['title'] = $form_title;

                $user_options['sub_text'] = $sub_text;

                $user_options['role_permission'] = $role_permission;

                $user_options['smtp_connect'] = $connect_smtp;

                $user_options['cron'] = $use_cron_job;

                $user_options['pass'] = $auto_pass;

                $user_options['color'] = $theme_color;

                update_option("BMSI_User_Options", $user_options);

                $option = get_option("BMSI_User_Options");



                $message = "Changes Saved.";

                $title = "Well Done!";

                $response = [

                    'status' => true,

                    'message' => esc_html($message, 'bulk-mail'),

                    'title' => esc_html($title, 'bulk-mail'),

                ];

            } else {

                $message = "Activation key is requied.";

                $title = "Alert!";

                $response = [

                    'status' => false,

                    'message' => esc_html($message, 'bulk-mail'),

                    'title' => esc_html($title, 'bulk-mail'),

                ];

            }



        } else {

            $history_permission = !empty($_POST["checked"]) ? sanitize_text_field($_POST["checked"]) : "";

            $form_title = !empty($_POST["form_title"]) ? sanitize_text_field($_POST["form_title"]) : "";

            $sub_text = !empty($_POST["sub_text"]) ? sanitize_text_field($_POST["sub_text"]) : "";

            $role_permission = !empty($_POST["role_permission"]) ? sanitize_text_field($_POST["role_permission"]) : "";

            $connect_smtp = !empty($_POST["connect_smtp"]) ? sanitize_text_field($_POST["connect_smtp"]) : "";

            $use_cron_job = !empty($_POST["use_cron_job"]) ? sanitize_text_field($_POST["use_cron_job"]) : "";

            $auto_pass = !empty($_POST["auto_pass"]) ? sanitize_text_field($_POST["auto_pass"]) : "";



            $user_options['permission'] = $history_permission;

            $user_options['title'] = $form_title;

            $user_options['sub_text'] = $sub_text;

            $user_options['role_permission'] = $role_permission;

            $user_options['smtp_connect'] = $connect_smtp;

            $user_options['cron'] = $use_cron_job;

            $user_options['pass'] = $auto_pass;

            update_option("BMSI_User_Options", $user_options);

            $option = get_option("BMSI_User_Options");



            $message = "Changes Saved.";

            $title = "Well Done!";

            $response = [

                'status' => true,

                'message' => esc_html($message, 'bulk-mail'),

                'title' => esc_html($title, 'bulk-mail'),

            ];

        }







        header('Content-Type: application/json');

        echo wp_json_encode($response);

        wp_die();



    }



    public function BMSI_create_new_user_callback()

    {

        if (!isset($_POST['create_user_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['create_user_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $option = get_option("BMSI_User_Options");



        $fname = !empty($_POST['fname']) ? sanitize_text_field($_POST['fname']) : "";

        $lname = !empty($_POST['lname']) ? sanitize_text_field($_POST['lname']) : "";

        $email = !empty($_POST['email']) ? sanitize_text_field($_POST['email']) : "";

        $mobile = !empty($_POST['mobile']) ? sanitize_text_field($_POST['mobile']) : null;

        $role = isset($_POST['role']) ? sanitize_text_field($_POST['role']) : "subscriber";



        if (isset($option["pass"]) && $option["pass"] == "true") {





            $password = wp_generate_password($length = 12, $include_standard_special_chars = false);



            $subject = "Bulk Mail Sender User Name and Password";

            $message = "User Name :- " . $fname . " " . $lname;

            $message .= "    Password :- " . $password;

            $headers = array('Content-Type: text/html; charset=UTF-8');



            wp_mail($email, $subject, $message, $headers);



        } else {



            $password = !empty($_POST['pass']) ? sanitize_text_field($_POST['pass']) : "";



        }



        $username = $fname . " " . $lname;



        if (username_exists($username) || email_exists($email)) {

            $message = 'User already exists';

            $title = "Alert!";

            $response = [

                'status' => true,

                'message' => esc_html($message, 'bulk-mail'),

                'title' => esc_html($title, 'bulk-mail'),

            ];

        } else {

            $user_id = wp_create_user($username, $password, $email);



            if ($user_id) {



                $user = get_user_by('ID', $user_id);

                $user->set_role($role);



                $meta_updated = update_user_meta($user_id, 'mobile', $mobile);



                $message = 'User Created Successfully.';

                $title = "Congratulations!";

                $response = [

                    'status' => true,

                    'message' => esc_html($message, 'bulk-mail'),

                    'title' => esc_html($title, 'bulk-mail'),

                ];



            } else {

                $message = 'Invalid User.';

                $title = "Alert!";

                $response = [

                    'status' => false,

                    'message' => esc_html($message, 'bulk-mail'),

                    'title' => esc_html($title, 'bulk-mail'),

                ];



            }





        }



        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();





    }



    public function BMSI_User_send_mail_template_callback()

    {

        if (!isset($_POST['send_mail_user_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['send_mail_user_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $today_date = date('Y-m-d');

        $option = get_option("BMSI_User_Options");



        global $wpdb;

        $table_mail_details = $wpdb->prefix . 'bmsi_pro_send_mail_details';

        $table_total_mail = $wpdb->prefix . 'bmsi_total_mail';

        $tbl_mail_details = $wpdb->prefix . 'bmsi_mail_details';

        $tbl_send_mail_details = $wpdb->prefix . 'bmsi_send_mail_details';

        $table_history = $wpdb->prefix . 'bmsi_history';

        $mail_counter = 0;

        $total_mail_result_query = $wpdb->prepare("SELECT * FROM %1s", $table_total_mail);

        $total_mail_result = $wpdb->get_results($total_mail_result_query);

        $today_mail_result_query = $wpdb->prepare("SELECT * FROM %1s ORDER BY createdate DESC LIMIT 1", $table_total_mail);

        $today_mail_result = $wpdb->get_results($today_mail_result_query);



        $template_name = isset($_POST['template_name']) ? intval($_POST['template_name']) : "";

        $subject = isset($_POST['subject']) ? sanitize_text_field($_POST['subject']) : "";

        $sender_name = isset($_POST['sender_name']) ? sanitize_text_field($_POST['sender_name']) : "";

        $sender_mail = isset($_POST['sender_mail']) ? sanitize_text_field($_POST['sender_mail']) : "";



        $count = 0;

        $all_users = get_users();

        $user_emails = array();



        foreach ($all_users as $user) {

            $user_emails[] = $user->user_email;

            $user_id = $user->ID;

        }



        if (!empty($template_name)) {



            $table = $wpdb->prefix . 'bmsi_design_template';



            $data = $wpdb->get_results($wpdb->prepare("SELECT message From {$table} where id = %d", $template_name));



            if (!empty($data)) {



                foreach ($user_emails as $email) {



                    if (isset($email)) {

                        $user_email = $email;

                        $message = $data[0]->message;

                        $from_header = 'From: ' . $sender_name . ' <' . $sender_mail . '>';

                        $headers = array(

                            $from_header,

                            'Content-Type: text/html; charset=UTF-8'

                        );



                        $details_data = [

                            'from_mail' => $sender_mail,

                            'from_name' => $sender_name,

                            'subject' => $subject,

                            'body' => $message,

                        ];



                        if ($option["permission"] == "true") {

                            $insert_detail_data = $wpdb->insert(

                                $tbl_mail_details,

                                $details_data,

                            );



                            $sender_id = $wpdb->insert_id;

                        }





                        $pro_details_data = array(

                            'from_name' => $sender_name,

                            'subject' => $subject,

                            'body' => $message,

                            'type' => 'template',

                            'createdate' => $today_date,

                        );



                        $pro_insert_detail_data = $wpdb->insert(

                            $table_mail_details,

                            $pro_details_data,

                        );



                        if ($option["permission"] == "true") {

                            $insert_detail = $wpdb->insert(

                                $table_history,

                                $pro_details_data

                            );

                            $email_id = $wpdb->insert_id;



                            if ($email_id) {

                                $tracking_pixel_url = plugins_url('track.php', __FILE__) . '?id=' . $email_id;

                                $tracking_pixel = '<img src="' . esc_url($tracking_pixel_url) . '" alt="track" width="1" height="1" border="0" />';

                                $message .= $tracking_pixel;

                            }

                        }



                        if (isset($option["cron"]) && $option["cron"] == "true") {

                            $email_queue = new BMSIEmailQueue;



                            $result_mail = $email_queue->add_to_email_queue($email, $subject, $message, $headers);



                            $count++;

                        } else {

                            $result_mail = wp_mail($email, $subject, $message, $headers);



                            $count++;

                        }





                        if ($insert_detail !== false) {

                            if ($result_mail === false) {

                                $wpdb->delete(

                                    $table_history,

                                    array('id' => $email_id)

                                );

                            }

                        }





                        if ($result_mail) {

                            $mail_counter++;

                        }





                    }

                }

            }



            if (!empty($total_mail_result)) {

                if ($today_mail_result[0]->createdate === $today_date) {

                    $total_news_mail = $today_mail_result[0]->newsleeter;

                    $total_user_mail = $today_mail_result[0]->user + $mail_counter;

                    $total_mail = $today_mail_result[0]->total + $mail_counter;

                    $total_mail_details_data = array(

                        'total' => $total_mail,

                        'user' => $total_user_mail,

                        'newsleeter' => $total_news_mail

                    );

                    $where = array(

                        'createdate' => $today_date

                    );

                    $wpdb->update($table_total_mail, $total_mail_details_data, $where);

                } else {

                    $total_mail_details_data = array(

                        'total' => $mail_counter,

                        'user' => $mail_counter,

                        'newsleeter' => 0,

                        'createdate' => $today_date

                    );

                    $wpdb->insert(

                        $table_total_mail,

                        $total_mail_details_data,

                    );

                }

            } else {

                $total_mail_details_data = array(

                    'total' => $mail_counter,

                    'user' => $mail_counter,

                    'newsleeter' => 0,

                    'createdate' => $today_date

                );

                $wpdb->insert(

                    $table_total_mail,

                    $total_mail_details_data,

                );

            }



            if ($count > 0) {

                if ($result_mail > 0) {

                    $message = "Mail Send Successfully.";

                    $title = "Well Done!";

                    $response = [

                        'status' => true,

                        'message' => esc_html($message, 'bulk-mail'),

                        'title' => esc_html($title, 'bulk-mail'),

                    ];

                } else {

                    $message = "Mail Send Failed.";

                    $title = "Alert!";

                    $response = [

                        'status' => false,

                        'title' => esc_html($title, 'bulk-mail'),

                        'message' => esc_html($message, 'bulk-mail'),

                    ];

                }

            } else {

                $message = "No users are available.";

                $title = "Alert!";



                $response = [

                    'status' => false,

                    'title' => esc_html($title, 'bulk-mail'),

                    'message' => esc_html($message, 'bulk-mail'),

                ];

            }

        } else {

            $message = "No Template Found.";

            $title = "Alert!";



            $response = [

                'status' => false,

                'title' => esc_html($title, 'bulk-mail'),

                'message' => esc_html($message, 'bulk-mail'),

            ];

        }



        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();



    }



    public function BMSI_User_send_mail_template_newsletter_callback()

    {

        if (!isset($_POST['send_mail_user_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['send_mail_user_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $option = get_option("BMSI_User_Options");

        $today_date = date('Y-m-d');



        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_news_letters_email';

        $table_pro_send_email = $wpdb->prefix . 'bmsi_pro_send_mail_details';

        $table_total_mail = $wpdb->prefix . 'bmsi_total_mail';

        $tbl_send_mail_details = $wpdb->prefix . 'bmsi_send_mail_details';

        $table_history = $wpdb->prefix . 'bmsi_history';

        $results = $wpdb->get_results("SELECT * FROM $table_name");

        $total_mail_result = $wpdb->get_results("SELECT * FROM $table_total_mail");

        $today_mail_result = $wpdb->get_results("SELECT * FROM $table_total_mail ORDER BY createdate DESC LIMIT 1");

        $mail_counter = 0;

        $count = 0;



        $template_id = isset($_POST['template_name']) ? intval($_POST['template_name']) : "";

        $subject = isset($_POST['subject']) ? sanitize_text_field($_POST['subject']) : "";

        $sender_name = isset($_POST['sender_name']) ? sanitize_text_field($_POST['sender_name']) : "";

        $sender_mail = isset($_POST['sender_mail']) ? sanitize_text_field($_POST['sender_mail']) : "";



        $status = isset($_POST['status']) ? intval($_POST['status']) : "";



        $overall_result = false;



        $table = $wpdb->prefix . 'bmsi_news_letter_category';

        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';



        $parent_id = isset($_POST['parentcategory']) ? intval($_POST['parentcategory']) : "";

        $sub_id = isset($_POST['subcategory']) ? intval($_POST['subcategory']) : 0;





        if (!empty($sub_id) && $sub_id > 0) {



            $parent_data = $wpdb->get_results($wpdb->prepare("SELECT parent_category_id FROM $table_sub_category WHERE id = %d", $sub_id));

            $parent_id = $parent_data[0]->parent_category_id;



        }



        if (!empty($template_id)) {



            $table = $wpdb->prefix . 'bmsi_design_template';



            $data = $wpdb->get_results($wpdb->prepare("SELECT message From {$table} where id = %d", $template_id));



            if (!empty($data[0]->message)) {



                foreach ($results as $user) {



                    if (isset($user->email)) {

                        $email = $user->email;

                        $user_id = $user->id;

                        $user_parent_category = $user->category;

                        $user_sub_category = $user->sub_category;

                        $user_status = $user->status;

                        $message = $data[0]->message;

                        $headers = array(

                            'From: ' . $sender_name . ', <' . $sender_mail . '>',

                            'Content-Type: text/html; charset=UTF-8'

                        );



                        $details_data = array(

                            'from_name' => $sender_name,

                            'subject' => $subject,

                            'body' => $message,

                            'type' => 'template',

                            'createdate' => $today_date,

                        );



                        $insert_detail_data = $wpdb->insert(

                            $table_pro_send_email,

                            $details_data

                        );



                        $result = false;



                        if ($option["permission"] == "true") {

                            $insert_detail = $wpdb->insert(

                                $table_history,

                                $details_data

                            );

                            $email_id = $wpdb->insert_id;



                            if ($email_id) {

                                $tracking_pixel_url = plugins_url('track.php', __FILE__) . '?id=' . $email_id;

                                $tracking_pixel = '<img src="' . esc_url($tracking_pixel_url) . '" alt="track" width="1" height="1" border="0" />';

                                $message .= $tracking_pixel;

                            }

                        }



                        if (isset($option["cron"]) && $option["cron"] == "true") {

                            if ($user_parent_category == $parent_id) {

                                if (!empty($sub_id) && $user_sub_category == $sub_id) {

                                    if ($user_status == $status) {

                                        $email_queue = new BMSIEmailQueue;



                                        $result = $email_queue->add_to_email_queue($email, $subject, $message, $headers);

                                        $count++;

                                    } else {

                                        if ($status == "2") {

                                            $email_queue = new BMSIEmailQueue;



                                            $result = $email_queue->add_to_email_queue($email, $subject, $message, $headers);

                                            $count++;

                                        }

                                    }

                                } else {

                                    if ($user_status == $status) {

                                        $email_queue = new BMSIEmailQueue;



                                        $result = $email_queue->add_to_email_queue($email, $subject, $message, $headers);

                                        $count++;

                                    } else {

                                        if ($status == "2") {

                                            $email_queue = new BMSIEmailQueue;



                                            $result = $email_queue->add_to_email_queue($email, $subject, $message, $headers);

                                            $count++;

                                        }

                                    }

                                }

                            } else {



                                if ($parent_id == "0") {

                                    if ($user_status == $status) {

                                        $email_queue = new BMSIEmailQueue;



                                        $result = $email_queue->add_to_email_queue($email, $subject, $message, $headers);

                                        $count++;

                                    } else {

                                        if ($status == "2") {

                                            $email_queue = new BMSIEmailQueue;



                                            $result = $email_queue->add_to_email_queue($email, $subject, $message, $headers);

                                            $count++;

                                        }

                                    }

                                }

                            }

                        } else {

                            if ($user_parent_category == $parent_id) {

                                if (!empty($sub_id) && $user_sub_category == $sub_id) {

                                    if ($user_status == $status) {

                                        $result = wp_mail($email, $subject, $message, $headers);

                                        $count++;

                                    } else {

                                        if ($status == "2") {

                                            $result = wp_mail($email, $subject, $message, $headers);

                                            $count++;

                                        }

                                    }

                                } else {

                                    if ($user_status == $status) {

                                        $result = wp_mail($email, $subject, $message, $headers);

                                        $count++;

                                    } else {

                                        if ($status == "2") {

                                            $result = wp_mail($email, $subject, $message, $headers);

                                            $count++;

                                        }

                                    }

                                }

                            } else {

                                if ($parent_id == "0") {

                                    if ($user_status == $status) {

                                        $result = wp_mail($email, $subject, $message, $headers);

                                        $count++;

                                    } else {

                                        if ($status == "2") {

                                            $result = wp_mail($email, $subject, $message, $headers);

                                            $count++;

                                        }

                                    }

                                }

                            }

                        }



                        if ($insert_detail !== false) {

                            if ($result === false) {

                                $wpdb->delete(

                                    $table_history,

                                    array('id' => $email_id)

                                );

                            }

                        }



                        if ($insert_detail_data !== false && $result !== false) {

                            $mail_counter++;

                            $overall_result = true;

                        }

                    }

                }

            }



            if (!empty($total_mail_result)) {

                if ($today_mail_result[0]->createdate === $today_date) {

                    $total_news_mail = $today_mail_result[0]->newsleeter + $mail_counter;

                    $total_user_mail = $today_mail_result[0]->user;

                    $total_mail = $today_mail_result[0]->total + $mail_counter;

                    $total_mail_details_data = array(

                        'total' => $total_mail,

                        'user' => $total_user_mail,

                        'newsleeter' => $total_news_mail

                    );

                    $where = array(

                        'createdate' => $today_date

                    );

                    $wpdb->update($table_total_mail, $total_mail_details_data, $where);



                } else {

                    $total_mail_details_data = array(

                        'total' => $mail_counter,

                        'user' => 0,

                        'newsleeter' => $mail_counter,

                        'createdate' => $today_date

                    );

                    $wpdb->insert(

                        $table_total_mail,

                        $total_mail_details_data

                    );

                }

            } else {

                $total_mail_details_data = array(

                    'total' => $mail_counter,

                    'user' => 0,

                    'newsleeter' => $mail_counter,

                    'createdate' => $today_date

                );

                $wpdb->insert(

                    $table_total_mail,

                    $total_mail_details_data

                );

            }



            if ($count > 0) {

                if ($overall_result) {

                    $message = "Mail Send Successfully.";

                    $title = "Well Done!";



                    $response = [

                        'status' => true,

                        'message' => esc_html($message, 'bulk-mail'),

                        'title' => esc_html($title, 'bulk-mail'),

                    ];

                } else {

                    $message = "Mail Send Failed.";

                    $title = "Alert!";

                    $response = [

                        'status' => false,

                        'title' => esc_html($title, 'bulk-mail'),

                        'message' => esc_html($message, 'bulk-mail'),

                    ];

                }

            } else {

                $message = "No users are available.";

                $title = "Alert!";

                $response = [

                    'status' => false,

                    'title' => esc_html($title, 'bulk-mail'),

                    'message' => esc_html($message, 'bulk-mail'),

                ];

            }



        } else {

            $title = "Alert!";

            $message = "No Template Found.";

            $response = [

                'status' => false,

                'title' => esc_html($title, 'bulk-mail'),

                'message' => esc_html($message, 'bulk-mail'),

            ];

        }



        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();





    }



    public function BMSI_User_send_mail_manual_news_letter_callback()

    {

    

       



        if (!isset($_POST['send_mail_user_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['send_mail_user_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }

    

        $option = get_option("BMSI_User_Options");

        $today_date = date('Y-m-d');



        global $wpdb;

        $table_all_mail = $wpdb->prefix . 'bmsi_all_mail';

        $table_all_detail = $wpdb->prefix . 'bmsi_all_mail_detail';

        $table_name = $wpdb->prefix . 'bmsi_news_letters_email';

        $table_send_mail = $wpdb->prefix . 'bmsi_pro_send_mail_details';

        $table_total_mail = $wpdb->prefix . 'bmsi_total_mail';

        $table_history = $wpdb->prefix . 'bmsi_history';

        

        $status = isset($_POST['status']) ? intval($_POST['status']) : " ";



        $results = $wpdb->get_results("SELECT * FROM `{$table_name}` where status = $status");

        $total_mail_result = $wpdb->get_results("SELECT * FROM `{$table_total_mail}`");

        $today_mail_result = $wpdb->get_results("SELECT * FROM `{$table_total_mail}` ORDER BY createdate DESC LIMIT 1");

        $mail_counter = 0;

        $count = 0;

        $overall_result = false;



        $subject = !empty($_POST['subject']) ? sanitize_text_field($_POST['subject']) : "";

        $sender = !empty($_POST['sender']) ? sanitize_text_field($_POST['sender']) : "";

        $sender_mail = !empty($_POST['sender_id']) ? sanitize_text_field($_POST['sender_id']) : "";

       



        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';



        $parent_id = isset($_POST['parentcategory']) ? intval($_POST['parentcategory']) : "";

        $sub_id = isset($_POST['subcategory']) ? intval($_POST['subcategory']) : "";

        $message = !empty($_POST['body']) ? stripslashes($_POST['body']) : " ";

       



        if (!empty($sub_id)) {

            $table_sub_category_safe = esc_sql($table_sub_category);

            $parent_data = $wpdb->get_results(

                $wpdb->prepare(

                    "SELECT `parent_category_id` FROM `{$table_sub_category_safe}` WHERE id = %d",

                    $sub_id

                )

            );

            $parent_id = $parent_data[0]->parent_category_id;

        }



            

        $all_mail_detail = [

            'body' => $message,

        ];

        $insert_all_detail_deta = $wpdb->insert(

            $table_all_detail,

            $all_mail_detail

        );

        $insert_id = $wpdb->insert_id;



       

        if (!empty($results)) {

            foreach ($results as $user) {

                if (isset($user->email)) {



                    $email = $user->email;

                    $user_id = $user->id;

                    $user_parent_category = $user->category;

                    $user_sub_category = $user->sub_category;

                    $user_status = $user->status;

                 

                    if ($user_parent_category != $parent_id) {

                        continue;

                    }

                    if(!empty($sub_id)){

                        if($sub_id != $user_sub_category){

                            continue;

                        }

                    }

            

                   

                     $all_mail = [

                        'subject' => $subject,

                        'from_name'=> $sender,

                        'from_mail' => $sender_mail,

                        'to_mail' => $email,

                        'email_send_id' => $insert_id,

                        'category' => $parent_id,

                        'status' => $status,

                    ];

                    

        

                    

                    $insert_detail_data = $wpdb->insert(

                        $table_all_mail,

                        $all_mail

                    );

                    

                   

            

                

                }

            }

           

        }

       

       



        if ($insert_detail_data) {

          

            $message = "Mail Saved Successfully";

            $title = "Well Done!";

            $response = [

                'status' => true,

                'message' => esc_html($message, 'bulk-mail'),

                'title' => esc_html($title, 'bulk-mail'),

            ];

         

        } else {

            $message = "No users are available";

            $title = "Alert!";

            $response = [

                'status' => false,

                'title' => esc_html($title, 'bulk-mail'),

                'message' => esc_html($message, 'bulk-mail'),

            ];

        }



        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();

    }



    public function BMSI_per_hour_send_mail_callback(){



        if (!isset($_POST['per_hour_nounce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['per_hour_nounce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }

        $per_hour = !empty($_POST['per_hour']) ? sanitize_text_field($_POST['per_hour']) : "";





        $send_mail = update_option("BMSI_per_hour_send_mail", $per_hour);



        $message = "Setting Save Successfully";

        $title = "Success!";

        $response = [

            'status' => false,

            'title' => esc_html($title, 'bulk-mail'),

            'message' => esc_html($message, 'bulk-mail'),

        ];

    

        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();

       

    }

    public function BMSI_SMTP_Connect_callback()

    {

        if (!isset($_POST['smtp_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['smtp_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $smtpH = !empty($_POST['smtpH']) ? sanitize_text_field($_POST['smtpH']) : "";

        $smtpPort = !empty($_POST['smtpPort']) ? sanitize_text_field($_POST['smtpPort']) : "";

        $smtpU = !empty($_POST['smtpU']) ? sanitize_text_field($_POST['smtpU']) : "";

        $smtpPass = !empty($_POST['smtpPass']) ? sanitize_text_field($_POST['smtpPass']) : "";

        $Secure = !empty($_POST['Secure']) ? sanitize_text_field($_POST['Secure']) : "";

        $Authentication = !empty($_POST['Authentication']) ? sanitize_text_field($_POST['Authentication']) : "";

        $connect_smtp = !empty($_POST['connect_smtp']) ? sanitize_text_field($_POST['connect_smtp']) : "";



        $smtp_option['smtpH'] = $smtpH;

        $smtp_option['smtpPort'] = $smtpPort;

        $smtp_option['smtpU'] = $smtpU;

        $smtp_option['smtpPass'] = $smtpPass;

        $smtp_option['Secure'] = $Secure;

        $smtp_option['Authentication'] = $Authentication;

        update_option("BMSI_SMTP_Options", $smtp_option);

        $option = get_option("BMSI_SMTP_Options");



        $user_option = get_option("BMSI_User_Options");





        if ($connect_smtp == "true") {



            global $phpmailer;



            if (!($phpmailer instanceof PHPMailer)) {

                require_once ABSPATH . WPINC . '/PHPMailer/PHPMailer.php';

                require_once ABSPATH . WPINC . '/PHPMailer/SMTP.php';

                require_once ABSPATH . WPINC . '/PHPMailer/Exception.php';

            }



            $phpmailer = new PHPMailer(true);



            $smtp_option = get_option('BMSI_SMTP_Options');



            try {

                $phpmailer->isSMTP();

                $phpmailer->Host = $smtp_option["smtpH"] ?? '';

                $phpmailer->SMTPAuth = true;

                $phpmailer->Port = $smtp_option["smtpPort"] ?? 587;

                $phpmailer->Username = $smtp_option["smtpU"] ?? '';

                $phpmailer->Password = $smtp_option["smtpPass"] ?? '';

                $phpmailer->SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS; // Default to TLS



                if (!empty($smtp_option["Secure"]) && strtolower($smtp_option["Secure"]) === "ssl") {

                    $phpmailer->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;

                    $phpmailer->Port = 465;

                    $phpmailer->SMTPAutoTLS = false; // Disable AutoTLS if using SSL

                } else {

                    $phpmailer->SMTPAutoTLS = true; // Enable AutoTLS for TLS

                }



                // Attempt to connect to the SMTP server

                if ($phpmailer->smtpConnect()) {

                    $message = "SMTP connection successful.";

                    $title = "Success!";

                    $response = [

                        'status' => true,

                        'title' => esc_html($title, 'bulk-mail'),

                        'message' => esc_html($message, 'bulk-mail'),

                    ];

                } else {

                    $message = "SMTP connection failed.";

                    $title = "Alert!";

                    $response = [

                        'status' => false,

                        'title' => esc_html($title, 'bulk-mail'),

                        'message' => esc_html($message, 'bulk-mail'),

                    ];

                }

            } catch (Exception $e) {



                $message = 'Mailer Error: ' . $e->getMessage();

                $title = "Alert!";

                $response = [

                    'status' => false,

                    'title' => esc_html($title, 'bulk-mail'),

                    'message' => esc_html($message, 'bulk-mail'),

                ];

            }

        } else {

            $message = "Plz check smtp checkbox.";

            $title = "Alert!";

            $response = [

                'status' => false,

                'title' => esc_html($title, 'bulk-mail'),

                'message' => esc_html($message, 'bulk-mail'),

            ];

        }



        header('Content-Type: application/json');

        echo json_encode($response);

        wp_die();

    }



    public function configure_phpmailer_callback(PHPMailer $phpmailer)

    {

        $option = get_option("BMSI_User_Options");



        if (!empty($option['smtp_connect']) && $option['smtp_connect'] === "true") {

            $this->BMSI_PHPMailer_Connect_callback($phpmailer);

        } else {

            $this->BMSI_PHPMailer_callback($phpmailer);

        }

    }



    public function BMSI_PHPMailer_Connect_callback(PHPMailer $phpmailer)

    {

        $smtp_option = get_option('BMSI_SMTP_Options');



        $phpmailer->isSMTP();

        $phpmailer->Host = $smtp_option["smtpH"] ?? '';

        $phpmailer->SMTPAuth = true;

        $phpmailer->Port = $smtp_option["smtpPort"] ?? 587;

        $phpmailer->Username = $smtp_option["smtpU"] ?? '';

        $phpmailer->Password = $smtp_option["smtpPass"] ?? '';

        $phpmailer->SMTPSecure = $smtp_option["Secure"] ?? 'tls';



        if (!empty($smtp_option["Secure"]) && strtolower($smtp_option["Secure"]) === "ssl") {

            $phpmailer->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;

            $phpmailer->Port = 465; 

            $phpmailer->SMTPAutoTLS = false;

        } else {

            $phpmailer->SMTPAutoTLS = true;

        }

    }



    public function BMSI_PHPMailer_callback(PHPMailer $phpmailer)

    {

        $phpmailer->isMail();

    }





    public function BMSI_display_history_callback()

    {

        if (!isset($_POST['history_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['history_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;

        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;

        $search = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : "";



        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_history';



        $query_table1 = $wpdb->prepare("SELECT * FROM %1s", $table_name);



        if (!empty($search)) {

            $query_table1 .= $wpdb->prepare(" WHERE from_name LIKE %s", '%' . $wpdb->esc_like($search) . '%');

        }



        $query_table1 .= $wpdb->prepare(" ORDER BY id DESC LIMIT %d, %d", $start, $length);



        $query_table2 = $wpdb->prepare("SELECT COUNT(*) FROM %1s", $table_name);



        $results_table = $wpdb->get_results($query_table1);



        $total_filtered_records = $wpdb->get_var($query_table2);



        $chart_data = array();

        foreach ($results_table as $row) {

            $chart_data[] = array(

                'id' => $row->id,

                'from_name' => $row->from_name,

                'subject' => $row->subject,

                'createdate' => $row->createdate,

                'open' => $row->open_count,

            );

        }



        $response = [

            'draw' => intval($_POST['draw']),

            'recordsTotal' => $total_filtered_records,

            'recordsFiltered' => $total_filtered_records,

            'data' => $chart_data

        ];



        header('Content-Type: application/json');

        echo wp_json_encode($response);

        wp_die();

    }





    public function BMSI_view_history_callback()

    {

        if (!isset($_POST['history_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['history_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        $start = isset($_POST['start']) ? intval($_POST['start']) : 0;

        $length = isset($_POST['length']) ? intval($_POST['length']) : 10;

        $search = isset($_POST["search"]["value"]) ? sanitize_text_field($_POST["search"]["value"]) : "";



        global $wpdb;

        $table_name = $wpdb->prefix . 'bmsi_history';



        $query_table1 = $wpdb->prepare("SELECT * FROM %1s", $table_name);



        if (!empty($search)) {

            $query_table1 .= $wpdb->prepare(" WHERE from_name LIKE %s", '%' . $wpdb->esc_like($search) . '%');

        }



        $query_table1 .= $wpdb->prepare(" ORDER BY id DESC LIMIT %d, %d", $start, $length);



        $query_table2 = $wpdb->prepare("SELECT COUNT(*) FROM %1s", $table_name);



        $results_table = $wpdb->get_results($query_table1);



        $total_filtered_records = $wpdb->get_var($query_table2);



        $chart_data = array();

        foreach ($results_table as $row) {

            $chart_data[] = array(

                'id' => $row->id,

                'from_name' => $row->from_name,

                'subject' => $row->subject,

                'createdate' => $row->createdate,

                'open' => $row->open_count,

            );

        }



        $response = [

            'draw' => intval($_POST['draw']),

            'recordsTotal' => $total_filtered_records,

            'recordsFiltered' => $total_filtered_records,

            'data' => $chart_data

        ];



        header('Content-Type: application/json');

        echo wp_json_encode($response);

        wp_die();

    }



    public function BMSI_register_settings()

    {

        $default_options = [];

        if (get_option('BMSI_User_Options') == false) {

            add_option('BMSI_User_Options');

            update_option($default_options, 'BMSI_User_Options');

        }

        register_setting('BMSI_register_settings', 'BMSI_User_Options');



        if (get_option('BMSI_SMTP_Options') == false) {

            add_option('BMSI_SMTP_Options');

            update_option($default_options, 'BMSI_SMTP_Options');

        }

        register_setting('BMSI_register_settings', 'BMSI_SMTP_Options');

    }

    public function BMSI_view_user_callback()

    {



        if (!isset($_POST['view_nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['view_nonce'])), 'ajax-nonce')) {

            die('Nonce verification failed');

        }



        if ($_SERVER['REQUEST_METHOD'] == "POST" && isset($_POST)) {

            $id = !empty($_POST['id']) ? sanitize_text_field($_POST['id']) : "";

            $user_data = get_user_by('ID', $id);

            $mobile = get_user_meta($id, 'mobile', true);

            $user_role = get_role_from_slug($user_data->roles[0]);

            $user[] = array(

                'id' => $user_data->ID,

                'uname' => $user_data->user_login,

                'email' => $user_data->user_email,

                'mobile_no' => $mobile,

                'role' => $user_role,

            );



            wp_send_json($user);

        }

    }



    public function save_email_template_callback()

    {

        if ($_SERVER['REQUEST_METHOD'] == "POST" && isset($_POST)) {
           $html_code = isset($_POST['html_content']) ? $_POST['html_content'] : "";
           $json_code = isset($_POST['json_content']) ? json_encode($_POST['json_content']) : "";
           $name = isset($_POST['template_name']) ? sanitize_text_field($_POST['template_name']) : "";

           if (!empty($html_code) && !empty($json_code)) {
               global $wpdb;
               $table = $wpdb->prefix . "bmsi_design_template";
               $alrdy_tname = $wpdb->get_results($wpdb->prepare("SELECT * FROM {$table} where name = %s", $name));
               if (empty($alrdy_tname)) {
                   $json = stripslashes($json_code);
                   $details = [
                       "message" => $html_code,
                       "json" => $json,
                       "name" => $name,
                   ];

                   $inser_date = $wpdb->insert(
                       $table,
                       $details
                   );


                   if ($inser_date) {
                       $message = "Template Save Successfully.";
                       $title = "Congration!";
                       $response = [
                           'status' => true,
                           'title' => esc_html($title, 'bulk-mail'),
                           'message' => esc_html($message, 'bulk-mail'),
                       ];
                   } else {
                       $message = "Something Went Wrong.";
                       $title = "Alert!";
                       $response = [
                           'status' => false,
                           'title' => esc_html($title, 'bulk-mail'),
                           'message' => esc_html($message, 'bulk-mail'),
                       ];
                   }
               } else {
                   $message = "Templaret Name Alerdy Exits.";
                   $title = "Alert!";
                   $response = [
                       'status' => false,
                       'title' => esc_html($title, 'bulk-mail'),
                       'message' => esc_html($message, 'bulk-mail'),
                   ];
               }
               wp_send_json_success($response);

            }

        }

    }



    public function get_saved_email_template_callback()

    {

        if ($_SERVER['REQUEST_METHOD'] == "POST") {



            $id = isset($_POST['template_id']) ? intval($_POST['template_id']) : "";



            global $wpdb;

            $table = $wpdb->prefix . 'bmsi_design_template';



            if ($id > 0) {

                $result = $wpdb->get_row($wpdb->prepare("SELECT json FROM {$table} where id = %d ORDER BY id DESC LIMIT 1", $id));

                // $json = htmlspecialchars_decode($result->json); // Decode HTML entities
                // $json = preg_replace('/[^\x20-\x7E]/', '', $json);

                // // Escape unescaped double quotes
                // $json = preg_replace('/(?<!\\\\)"/', '\"', $json);
                // Decode JSON
                $data = json_decode($result->json, true);

                // if ($data === null && json_last_error() !== JSON_ERROR_NONE) {
                //     // Handle JSON error
                //     echo "JSON decoding failed: " . json_last_error_msg();
                //     die;
                // }
                
                // // Remove slashes manually if they exist
                // $data = array_map(function($value) {
                //     if (is_string($value)) {
                //         // Remove extra spaces and unwanted characters
                //         $value = stripslashes($value);
                //         $value = str_replace("n", "", $value);
                //         $value = preg_replace('/\s+/', ' ', $value); 
                //         $value = preg_replace('/[^\x20-\x7E]/', '', $value); 
                       
                //     }
                //     return $value;
                // }, $data);
                
            
                // $data = json_decode($result->json, true);




                // Print JSON and PHP object for debugging


                



            } else {

                $data = '';

            }





            wp_send_json_success(['html_content' => $data]);





        }

    }



    public function get_category_callback()

    {

        global $wpdb;

        $table_category = $wpdb->prefix . 'bmsi_news_letter_category';

        $table_sub_category = $wpdb->prefix . 'bmsi_news_letter_sub_category';



        $parent_categories = $wpdb->get_results("SELECT * FROM $table_category");



        $subcategories = $wpdb->get_results("SELECT * FROM $table_sub_category");



        $grouped_subcategories = [];

        if (!empty($subcategories)) {

            foreach ($subcategories as $sub) {

                $grouped_subcategories[$sub->parent_category_id][] = $sub;

            }

        }



        if (!empty($parent_categories)) {

            foreach ($parent_categories as $category) {

                $category->subcategories = isset($grouped_subcategories[$category->id]) ? $grouped_subcategories[$category->id] : [];

            }

        }



        wp_send_json_success(['data' => $parent_categories]);

        wp_die();

    }



    public function get_user_from_email_callback()

    {

        $args = array(

            'role'    => 'administrator',

            'fields'  => array('user_email'), 

        );

        

        $users = get_users($args);



        $email = [];

        foreach ($users as $user) {

            $email[] = $user->user_email;

        }



        wp_send_json_success(['data' => $email]);

        wp_die();

    }



    public function BMSI_templat_email_body_callback()

    {

        $template = isset($_POST['template']) ? intval($_POST['template']) : "";



        global $wpdb;



        $table = $wpdb->prefix . 'bmsi_design_template';



        $data = $wpdb->get_results($wpdb->prepare("SELECT message From {$table} where id = %d", $template));



        wp_send_json_success($data);

        wp_die();



    }



    public function update_email_template_callback()

    {

        if ($_SERVER['REQUEST_METHOD'] == "POST" && isset($_POST)) {

            $html_code = isset($_POST['html_content']) ? $_POST['html_content'] : "";

            $json_code = isset($_POST['json_content']) ? json_encode($_POST['json_content']) : "";

            $template_id = isset($_POST['template_id']) ? intval($_POST['template_id']) : "";



            if (!empty($html_code) && !empty($json_code)) {

                global $wpdb;

                $table = $wpdb->prefix . "bmsi_design_template";



                $update_sql = $wpdb->prepare("

                UPDATE %1s SET `message` = '%s' , `json` = '%s' WHERE `id` = '%d'", $table, $html_code, $json_code, $template_id);



                $data = $wpdb->query($update_sql);



                if ($data) {

                    $message = "Template Save Successfully.";

                    $title = "Congration!";

                    $response = [

                        'status' => true,

                        'title' => esc_html($title, 'bulk-mail'),

                        'message' => esc_html($message, 'bulk-mail'),

                    ];

                } else {

                    $message = "Something Went Wrong.";

                    $title = "Alert!";

                    $response = [

                        'status' => true,

                        'title' => esc_html($title, 'bulk-mail'),

                        'message' => esc_html($message, 'bulk-mail'),

                    ];

                }





                wp_send_json_success($response);

            }

        }

    }



}

?>