jQuery(document).ready(function () {

    // close pro banner 
    jQuery("#closeButton").click(function (e) {
        e.preventDefault;
        var imageToShow = document.getElementById('pro_baneer');
        imageToShow.style.display = 'none';
    });



    // Display all user's data
    jQuery('#checkAll').change(function () {
        jQuery(':checkbox', '#get_all_users').prop('checked', this.checked);
    });

    var col1 = (BMSI_object.BMSI_Option[0] !== null && BMSI_object.BMSI_Option[0] !== undefined) ? BMSI_object.BMSI_Option[0].trim() : "id";
    var col2 = (BMSI_object.BMSI_Option[1] !== null && BMSI_object.BMSI_Option[1] !== undefined) ? BMSI_object.BMSI_Option[1].trim() : "uname";
    var col3 = (BMSI_object.BMSI_Option[2] !== null && BMSI_object.BMSI_Option[2] !== undefined) ? BMSI_object.BMSI_Option[2].trim() : "email";
    var col4 = (BMSI_object.BMSI_Option[3] !== null && BMSI_object.BMSI_Option[3] !== undefined) ? BMSI_object.BMSI_Option[3].trim() : "mobile_no";
    var col5 = (BMSI_object.BMSI_Option[4] !== null && BMSI_object.BMSI_Option[4] !== undefined) ? BMSI_object.BMSI_Option[4].trim() : "role";

    jQuery('#role_filter').on('change', function () {
        user_table.draw();
    });

    var user_table = jQuery('#get_all_users').DataTable({
        "searching": true,
        "filter": true,
        "processing": true,
        "serverSide": true,
        "bInfo": false,
        "ajax": {
            "url": BMSI_object.ajax_url,
            "type": "POST",
            "data": function (d) {
                d.action = "BMSI_display_users",
                    d.start_date = jQuery("#start").val(),
                    d.end_date = jQuery("#end").val(),
                    d.role = jQuery("#role_filter").val(),
                    d.user_nonce = BMSI_object.nonce
            },
        },
        language: {
            searchPlaceholder: "Search By Name",
            sLengthMenu: "Show  _MENU_  Entries",
            search: "",
            paginate: {
                "first": "<i class='fa-solid fa-backward'></i>",
                "last": "<i class='fa-solid fa-forward'></i>",
                "next": "<i class='fa-solid fa-caret-right'></i>",
                "previous": "<i class='fa-solid fa-caret-left'></i>"
            },
        },
        "columns": [
            { "data": "id", sortable: true },
            { "data": "uname", sortable: true },
            { "data": "email", sortable: true },
            { "data": "mobile_no", sortable: true },
            { "data": "role", sortable: true },
            {
                data: null,
                className: "dt-center editor-edit",
                sortable: false,
                render: function (data, type, row) {
                    return '<div><a href="' + BMSI_object.admin_url + 'user-edit.php?user_id=' + data.id + '&edit=true" id="editbtn_' + data.id + '" ><i class="fa-solid fa-user-pen"></i></a><a href="javascript:void(0);" data-bs-target="#exampleModal1" id="btn_view" data-bs-toggle="modal" onClick="view_record(' + data.id + ')"><i class="fa fa-eye" style="margin-right:3px;"></i></a>';
                }
            },
        ],
        "paging": true,
        "pageLength": 10,
        "select": true,
        "order": [
            [1, 'asc'],
        ],
    });

    var table = jQuery('#history_template').DataTable({
        "searching": true,
        "filter": true,
        "processing": true,
        "serverSide": true,
        "bInfo": false,
        "ajax": {
            "url": BMSI_object.ajax_url,
            "type": "POST",
            "data": {
                "action": "BMSI_display_history",
                "start_date": jQuery("#start").val(),
                "end_date": jQuery("#end").val(),
                "history_nonce": BMSI_object.nonce
            },
        },
        language: {
            searchPlaceholder: "Search By Name",
            sLengthMenu: "Show  _MENU_  Entries",
            search: "",
            paginate: {
                "first": "<i class='fa-solid fa-backward'></i>",
                "last": "<i class='fa-solid fa-forward'></i>",
                "next": "<i class='fa-solid fa-caret-right'></i>",
                "previous": "<i class='fa-solid fa-caret-left'></i>"
            },
        },
        "columns": [
            { "data": "from_name", sortable: true },
            { "data": "subject", sortable: true },
            { "data": "createdate", sortable: true },
            {
                "data": "open", sortable: false,
                render: function (data, type, row) {
                    return data + ' times read';
                }
            },
            {
                data: null,
                className: "dt-center editor-edit",
                sortable: false,
                render: function (data, type, row) {
                    return '<div><a href="javascript:void(0);" data-bs-target="#exampleModal1" id="btn_view" data-bs-toggle="modal" onClick="view_history(' + data.id + ')"><i class="fa fa-eye" style="margin-right:3px;"></i></a>';
                }
            },
        ],
        "paging": true,
        "pageLength": 10,
        "select": true,
        "order": [
            [1, 'asc'],
        ],
    });

    toggleForm(jQuery('#connect_smtp').is(':checked'));

    jQuery('#connect_smtp').change(function () {
        toggleForm(jQuery(this).is(':checked'));
    });

    function toggleForm(isChecked) {
        if (isChecked) {
            jQuery('.smtp_form_data').show();
        } else {
            jQuery('.smtp_form_data').hide();
        }
    }

    toggleNoteVisibility(jQuery('#use_cron_job').is(':checked'));

    jQuery('#use_cron_job').change(function () {
        toggleNoteVisibility(jQuery(this).is(':checked'));
    });

    function toggleNoteVisibility(isChecked) {
        if (isChecked) {
            jQuery('.mail_note').show();
        } else {
            jQuery('.mail_note').hide();
        }
    }

    jQuery("#btn-change").click(function (e) {
        e.preventDefault();
        jQuery("#sub_main .btn-txt").css("display", "none");
        jQuery("#sub_main .spinn").addClass("add_custome_loader");
        jQuery("#btn-change").attr('disabled', 'disabled');
        var value = jQuery("#save_history").is(":checked") ? "true" : "false";
        var role_permission = jQuery("#save_role_permission").is(":checked") ? "true" : "false";
        var connect_smtp = jQuery("#connect_smtp").is(":checked") ? "true" : "false";
        var use_cron_job = jQuery("#use_cron_job").is(":checked") ? "true" : "false";
        var auto_pass = jQuery("#auto_pass").is(":checked") ? "true" : "false";
        var title = jQuery("#form_title").val();
        var sub_text = jQuery("#sub_text").val();
        var theme_color = jQuery("#theme_color").val();

        jQuery.ajax({
            "url": BMSI_object.ajax_url,
            "type": "POST",
            "dataType": "JSON",
            "data": {
                "action": "BMSI_manage_setting",
                "checked": value,
                "role_permission": role_permission,
                "connect_smtp": connect_smtp,
                "use_cron_job": use_cron_job,
                "auto_pass": auto_pass,
                "form_title": title,
                "sub_text": sub_text,
                "theme_color": theme_color
            },
            success: function (response) {
                jQuery.confirm({
                    title: response.title,
                    content: response.message,
                    theme: 'modern',
                    buttons: {
                        ok: {
                            text: 'OK',
                            btnClass: 'add-button',
                            action: function () {
                                if (response.status == true) {
                                    location.reload();
                                }
                            }
                        }
                    }
                });
                jQuery("#sub_main .btn-txt").css("display", "block");
                jQuery("#sub_main .spinn").removeClass("add_custome_loader");
                jQuery("#btn-change").removeAttr('disabled');

            }, error: function (jqXHR, textStatus, errorThrown) {
                if (textStatus === 'timeout') {
                    jQuery.confirm({
                        title: "Alert!",
                        content: "The request timed out. Please try again",
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    return
                                }
                            }
                        }
                    });
                } else {
                    jQuery.confirm({
                        title: "Alert!",
                        content: "Something Went Wrong.",
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    return
                                }
                            }
                        }
                    });
                }
                jQuery("#sub_main .btn-txt").css("display", "block");
                jQuery("#sub_main .spinn").removeClass("add_custome_loader");
                jQuery("#btn-change").removeAttr('disabled');

            },
        });
    });

    jQuery('.use_template_form').hide();

    jQuery('input[type=radio][name=template_radio]').change(function (e) {
        e.preventDefault();
        var selected_option = jQuery('input[type=radio][name=template_radio]:checked').val();


        if (selected_option == "user_template") {
            jQuery('.manual_form').hide();
            jQuery('.use_template_form').show();
        } else {
            jQuery('.manual_form').show();
            jQuery('.use_template_form').hide();
        }

    });

    // user Form validation
    function validate_user_form() {
        return jQuery(".form_data").validate({
            rules: {
                fname: "required",
                lname: "required",
                email: "required",
                mob: "required",
            },
            messages: {
                fname: {
                    required: "First name is required."
                },
                lname: {
                    required: "Last name is required."
                },
                email: {
                    required: "Email is required."
                },
                mob: {
                    required: "Mobile Number is required."
                }
            },
        }).form();
    }

    // user Form validation
    function validate_send_mail_template_form() {
        return jQuery(".use_template_form").validate({
            rules: {
                template_name: "required",
            },
            messages: {
                template_name: {
                    required: "Template name is required."
                },
            },
        }).form();
    }


    //send mail form validation
    function validate_send_mail_form() {
        var isValid = jQuery(".send_mail_form").validate({
            rules: {
                subject: "required",
                mail_from: "required",
                admin_mail: "required",
                bmsi_mail_box_content: "required",
            },
            messages: {
                subject: {
                    required: "Subject is required."
                },
                mail_from: {
                    required: "Sender name is required."
                },
                admin_mail: {
                    required: "Sender email is required."
                },
                bmsi_mail_box_content: {
                    required: "Mail body is required."
                }
            },
        }).form();

        var editor = tinymce.get('bmsi_mail_box');

        if (editor && editor.getContent() == "<p>add some text</p>") {
            isValid = false;
            jQuery(".bmsi_mail_box_error").text("Mail body is required.");
        } else {
            jQuery(".bmsi_mail_box_error").text("");
        }

        return isValid;
    }


    function validate_send_mail_manual_form() {
        var isValid = jQuery(".manual_form").validate({
            rules: {
                subject: "required",
                mail_from: "required",
                admin_mail: "required",
                bmsi_mail_box_content: "required",
            },
            messages: {
                subject: {
                    required: "Subject is required."
                },
                mail_from: {
                    required: "Sender name is required."
                },
                admin_mail: {
                    required: "Sender email is required."
                },
                bmsi_mail_box_content: {
                    required: "Mail body is required."
                }
            },
        }).form();

        var bmsi_mail_box_content = tinymce.get('bmsi_mail_box').getContent();

        if (bmsi_mail_box_content == "<p>add some text</p>") {
            isValid = false;
            jQuery(".bmsi_mail_box_error").text("Mail body is required.");
        } else {
            jQuery("#bmsi_mail_box").text("");

        }

        return isValid;
    }

    jQuery(".btn_add_user").click(function (e) {
        e.preventDefault();

        if (!validate_user_form()) {
            return;
        }
        else {
            jQuery(".btn-txt").css("display", "none");
            jQuery(".spinn").addClass("add_custome_loader");
            jQuery(".btn_add_user").attr('disabled', 'disabled');

            var fname = jQuery("#fname").val();
            var lname = jQuery("#lname").val();
            var email = jQuery("#email").val();
            var mobile = jQuery("#mob").val();
            var role = jQuery("#role").val();
            var pass = jQuery("#pass").val();

            jQuery.ajax({
                "url": BMSI_object.ajax_url,
                "type": "POST",
                "dataType": "JSON",
                "data": {
                    "action": "BMSI_create_new_user",
                    "fname": fname,
                    "lname": lname,
                    "email": email,
                    "mobile": mobile,
                    "pass": pass,
                    "role": role,
                    "create_user_nonce": BMSI_object.nonce,

                },
                success: function (response) {
                    jQuery.confirm({
                        title: response.title,
                        content: response.message,
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    window.location.href = BMSI_object.admin_url + "admin.php?page=users";
                                }
                            }
                        }
                    });
                    jQuery(".btn-txt").css("display", "block");
                    jQuery(".spinn").removeClass("add_custome_loader");
                    jQuery(".btn_add_user").removeAttr('disabled');


                }, error: function (jqXHR, textStatus, errorThrown) {
                    if (textStatus === 'timeout') {
                        jQuery.confirm({
                            title: "Alert!",
                            content: "The request timed out. Please try again",
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        return
                                    }
                                }
                            }
                        });
                    } else {
                        jQuery.confirm({
                            title: "Alert!",
                            content: "Something Went Wrong.",
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        return
                                    }
                                }
                            }
                        });
                    }
                    jQuery("#tab4 .btn-txt").css("display", "block");
                    jQuery("#tab4 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn_add_user").removeAttr('disabled');

                },
            })
        }
    })


    jQuery(".btn-send-mail").click(function (e) {
        e.preventDefault();
        if (!validate_send_mail_form()) {
            return;
        }
        else {
            jQuery(".btn-txt").css("display", "none");
            jQuery(".spinn").addClass("add_custome_loader");
            jQuery(".btn-send-mail").attr('disabled', 'disabled');

            var subject = jQuery("#mail_sub").val();
            var sender_name = jQuery("#mail_from").val();
            var sender_email = jQuery("#admin_mail").val();

            var mail_contant = tinymce.get('bmsi_mail_box').getContent({ format: 'html' });


            jQuery.ajax({
                "url": BMSI_object.ajax_url,
                "type": "POST",
                "dataType": "JSON",
                "data": {
                    "action": "BMSI_User_send_mail",
                    "subject": subject,
                    "sender": sender_name,
                    "sender_email": sender_email,
                    "body": mail_contant,
                    "send_mail_user_nonce": BMSI_object.nonce,
                },
                success: function (response) {
                    jQuery.confirm({
                        title: response.title,
                        content: response.message,
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    if (response.status == true) {
                                        window.location.href = BMSI_object.admin_url + "admin.php?page=users";
                                    }
                                }
                            }
                        }
                    });
                    jQuery(".btn-txt").css("display", "block");
                    jQuery(".spinn").removeClass("add_custome_loader");
                    jQuery(".btn-send-mail").removeAttr('disabled');


                }, error: function (jqXHR, textStatus, errorThrown) {
                    if (textStatus === 'timeout') {
                        jQuery.confirm({
                            title: "Alert!",
                            content: "The request timed out. Please try again",
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        return
                                    }
                                }
                            }
                        });
                    } else {
                        jQuery.confirm({
                            title: "Alert!",
                            content: "Something Went Wrong.",
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        return
                                    }
                                }
                            }
                        });
                    }
                    jQuery("#tab4 .btn-txt").css("display", "block");
                    jQuery("#tab4 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn-send-mail").removeAttr('disabled');

                },
            });
        }
    });


    jQuery(".btn-pro-send-mail").click(function (e) {
        e.preventDefault();

        var selected_option = jQuery('input[type=radio][name=template_radio]:checked').val();

        if (selected_option == "user_template") {
            if (!validate_send_mail_template_form()) {
                return;
            } else {
                jQuery(".btn-txt").css("display", "none");
                jQuery(".spinn").addClass("add_custome_loader");
                jQuery(".btn-pro-send-mail").attr('disabled', 'disabled');


                var template_name = jQuery("#template_name").val();
                var subject = jQuery("#subject").val();
                var sender_name = jQuery("#sender_name").val();
                var sender_mail = jQuery("#admin_mail").val();

                jQuery.ajax({
                    "url": BMSI_object.ajax_url,
                    "type": "POST",
                    "data": {
                        "action": "BMSI_User_send_mail_template",
                        "template_name": template_name,
                        "subject": subject,
                        "sender_name": sender_name,
                        "sender_mail": sender_mail,
                        "send_mail_user_nonce": BMSI_object.nonce,
                    },
                    success: function (response) {
                        jQuery.confirm({
                            title: response.title,
                            content: response.message,
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        if (response.status == true) {
                                            window.location.href = BMSI_object.admin_url + "admin.php?page=users";
                                        }
                                    }
                                }
                            }
                        });
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-pro-send-mail").removeAttr('disabled');

                    }, error: function (jqXHR, textStatus, errorThrown) {
                        if (textStatus === 'timeout') {
                            jQuery.confirm({
                                title: "Alert!",
                                content: "The request timed out. Please try again",
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return
                                        }
                                    }
                                }
                            });
                        } else {
                            jQuery.confirm({
                                title: "Alert!",
                                content: errorThrown,
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return
                                        }
                                    }
                                }
                            });
                        }
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-pro-send-mail").removeAttr('disabled');

                    },
                });
            }
        }
        else {
            if (!validate_send_mail_form()) {
                return;
            }
            else {
                jQuery(".btn-txt").css("display", "none");
                jQuery(".spinn").addClass("add_custome_loader");
                jQuery(".btn-pro-send-mail").attr('disabled', 'disabled');


                var subject = jQuery("#mail_sub").val();
                var sender_name = jQuery("#mail_from").val();
                var sender_mail = jQuery("#admin_mail").val();
                var mail_contant = tinymce.get('bmsi_mail_box').getContent({ format: 'html' });


                jQuery.ajax({
                    "url": BMSI_object.ajax_url,
                    "type": "POST",
                    "dataType": "JSON",
                    "data": {
                        "action": "BMSI_pro_User_send_mail",
                        "subject": subject,
                        "sender": sender_name ,
                        "sender_mail": sender_mail,
                        "body": mail_contant,
                        "send_mail_user_nonce": BMSI_object.nonce,
                    },
                    success: function (response) {
                        jQuery.confirm({
                            title: response.title,
                            content: response.message,
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        if (response.status == true) {
                                            window.location.href = BMSI_object.admin_url + "admin.php?page=users";
                                        }
                                    }
                                }
                            }
                        });
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-pro-send-mail").removeAttr('disabled');


                    }, error: function (jqXHR, textStatus, errorThrown) {
                        if (textStatus === 'timeout') {
                            jQuery.confirm({
                                title: "Alert!",
                                content: "The request timed out. Please try again",
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return
                                        }
                                    }
                                }
                            });
                        } else {
                            jQuery.confirm({
                                title: "Alert!",
                                content: "Something Went Wrong.",
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return
                                        }
                                    }
                                }
                            });
                        }
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-pro-send-mail").removeAttr('disabled');

                    },
                });
            }
        }

    });

    // Send mail to news-letters
    jQuery(".btn-newslettter").click(function (e) {
        e.preventDefault();
        var selected_option = jQuery('input[type=radio][name=template_radio]:checked').val();

        if (selected_option === 'user_template') {
            if (!validate_send_mail_template_form()) {
                return;
            } else {
                jQuery(".btn-newslettter").attr('disabled', 'disabled');
                jQuery(".btn-txt").css("display", "none");
                jQuery(".spinn").addClass("add_custome_loader");


                var template_name = jQuery("#template_name").val();
                var status = jQuery("#Ustatus option:selected").val();
                var parentselectedCategory = '';
                var subselectedCategory = '';
                var subject = jQuery("#subject").val();
                var sender_name = jQuery("#sender_name").val();
                var sender_mail = jQuery("#admin_mail").val();

                parentselectedCategory = jQuery('#Newslettercategory').find('option:selected').filter(function () {
                    return jQuery(this).hasClass('level-0');
                }).val();

                subselectedCategory = jQuery('#Newslettercategory').find('option:selected').filter(function () {
                    return jQuery(this).hasClass('level-1');
                }).val();

                jQuery.ajax({
                    url: BMSI_object.ajax_url,
                    type: "POST",
                    dataType: "JSON",
                    data: {
                        action: "BMSI_User_send_mail_template_newsletter",
                        template_name: template_name,
                        parentcategory: parentselectedCategory,
                        subcategory: subselectedCategory,
                        status: status,
                        subject: subject,
                        sender_name: sender_name,
                        sender_mail: sender_mail,
                        send_mail_user_nonce: BMSI_object.nonce,
                    },
                    success: function (response) {
                        jQuery.confirm({
                            title: response.title,
                            content: response.message,
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        if (response.status === true) {
                                            window.location.href = BMSI_object.admin_url + "admin.php?page=newsletter";
                                        }
                                    }
                                }
                            }
                        });
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-newslettter").removeAttr('disabled');
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        if (textStatus === 'timeout') {
                            jQuery.confirm({
                                title: "Alert!",
                                content: "The request timed out. Please try again",
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return;
                                        }
                                    }
                                }
                            });
                        } else {
                            jQuery.confirm({
                                title: "Alert!",
                                content: "Something Went Wrong",
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return;
                                        }
                                    }
                                }
                            });
                        }
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-send-mail").removeAttr('disabled');
                    }
                });
            }

        } else {

            if (!validate_send_mail_manual_form()) {
                return;
            }
            else {
                jQuery(".btn-txt").css("display", "none");
                jQuery(".spinn").addClass("add_custome_loader");
                jQuery(".btn-newslettter").attr('disabled', 'disabled');

                var subject = jQuery("#mail_sub").val();
                var sender_name = jQuery("#mail_from").val();
                var sender_id = jQuery("#admin_mail").val();
                var mail_contant = tinymce.get('bmsi_mail_box').getContent({ format: 'html' });
                var parentselectedCategory = jQuery('#category').find('option:selected').filter(function () {
                    return jQuery(this).hasClass('level-0');
                }).val();

                var subselectedCategory = jQuery('#category').find('option:selected').filter(function () {
                    return jQuery(this).hasClass('level-1');
                }).val();

                console.log(subselectedCategory);

                var status = jQuery("#status option:selected").val();

                console.log(status);

                jQuery.ajax({
                    "url": BMSI_object.ajax_url,
                    "type": "POST",
                    "data": {
                        "action": "BMSI_User_send_mail_manual_news_letter",
                        "subject": subject,
                        "sender": sender_name,
                        "sender_id": sender_id,
                        "body": mail_contant,
                        "parentcategory": parentselectedCategory,
                        "subcategory": subselectedCategory,
                        "status": status,
                        "send_mail_user_nonce": BMSI_object.nonce,
                    },
                    success: function (response) {
                        jQuery.confirm({
                            title: response.title,
                            content: response.message,
                            theme: 'modern',
                            buttons: {
                                ok: {
                                    text: 'OK',
                                    btnClass: 'add-button',
                                    action: function () {
                                        if (response.status == true) {
                                            window.location.href = BMSI_object.admin_url + "admin.php?page=newsletter";
                                        }
                                    }
                                }
                            }
                        });
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-newslettter").removeAttr('disabled');

                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        if (textStatus === 'timeout') {
                            jQuery.confirm({
                                title: "Alert!",
                                content: "The request timed out. Please try again",
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return
                                        }
                                    }
                                }
                            });
                        } else {
                            jQuery.confirm({
                                title: "Alert!",
                                content: "Something Went Wrong.",
                                theme: 'modern',
                                buttons: {
                                    ok: {
                                        text: 'OK',
                                        btnClass: 'add-button',
                                        action: function () {
                                            return
                                        }
                                    }
                                }
                            });
                        }
                        jQuery(".btn-txt").css("display", "block");
                        jQuery(".spinn").removeClass("add_custome_loader");
                        jQuery(".btn-newslettter").removeAttr('disabled');

                    },

                });
            }

        }
    });

    // smtp setup 

    function validate_smtp_form() {
        return jQuery(".smtp_form_data").validate({
            rules: {
                smtpH: "required",
                smtpPort: "required",
                smtpU: "required",
                smtpPass: "required",
            },
            messages: {
                smtpH: {
                    required: "SMTP Host is required."
                },
                smtpPort: {
                    required: "SMTP Port is required."
                },
                smtpU: {
                    required: "SMTP Username is required."
                },
                smtpPass: {
                    required: "SMTP Password is required."
                }
            },
        }).form();
    }

    jQuery(".btn-Connect").click(function (e) {
        e.preventDefault();
        if (!validate_smtp_form()) {
            return;
        }
        else {
            jQuery("#tab4 .btn-txt").css("display", "none");
            jQuery("#tab4 .spinn").addClass("add_custome_loader");
            jQuery(".btn-Connect").attr('disabled', 'disabled');


            var smtpH = jQuery("#smtpH").val();
            var smtpPort = jQuery("#smtpPort").val();
            var smtpU = jQuery("#smtpU").val();
            var smtpPass = jQuery("#smtpPass").val();
            var Secure = jQuery("input[type='radio'][name='Secure']:checked").val();
            var Authentication = jQuery("input[type='radio'][name='Authentication']:checked").val();
            var connect_smtp = jQuery("#connect_smtp").is(":checked") ? "true" : "false";

            jQuery.ajax({
                "url": BMSI_object.ajax_url,
                "type": "POST",
                "dataType": "JSON",
                "data": {
                    "action": "BMSI_SMTP_Connect",
                    "smtpH": smtpH,
                    "smtpPort": smtpPort,
                    "smtpU": smtpU,
                    "smtpPass": smtpPass,
                    "Secure": Secure,
                    "Authentication": Authentication,
                    "connect_smtp": connect_smtp,
                    "smtp_nonce": BMSI_object.nonce,
                },
                success: function (response) {
                    jQuery.confirm({
                        title: response.title,
                        content: response.message,
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    if (response.status == true) {
                                        return
                                    }
                                }
                            }
                        }
                    });
                    jQuery("#tab4 .btn-txt").css("display", "block");
                    jQuery("#tab4 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn-Connect").removeAttr('disabled');


                },
                error: function (jqXHR, textStatus, errorThrown) {
                    jQuery.confirm({
                        title: "Alert!",
                        content: errorThrown,
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    return
                                }
                            }
                        }
                    });
                    jQuery("#tab4 .btn-txt").css("display", "block");
                    jQuery("#tab4 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn-Connect").removeAttr('disabled');

                },
                complete: function () {
                    jQuery("#tab4 .btn-txt").css("display", "block");
                    jQuery("#tab4 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn-Connect").removeAttr('disabled');

                }
            });
        }
    });

    jQuery(".btn-per-hour").click(function (e) {
        e.preventDefault();
        if (!validate_smtp_form()) {
            return;
        }
        else {
            jQuery("#tab3 .btn-txt").css("display", "none");
            jQuery("#tab3 .spinn").addClass("add_custome_loader");
            jQuery(".btn-per-hour").attr('disabled', 'disabled');


            var per_hour = jQuery("#per_hour").val();


            jQuery.ajax({
                "url": BMSI_object.ajax_url,
                "type": "POST",
                "dataType": "JSON",
                "data": {
                    "action": "BMSI_per_hour_send_mail",
                    "per_hour": per_hour,
                    "per_hour_nounce": BMSI_object.nonce,
                },
                success: function (response) {
                    jQuery.confirm({
                        title: response.title,
                        content: response.message,
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    if (response.status == true) {
                                        return
                                    }
                                }
                            }
                        }
                    });
                    jQuery("#tab3 .btn-txt").css("display", "block");
                    jQuery("#tab3 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn-per-hour").removeAttr('disabled');


                },
                error: function (jqXHR, textStatus, errorThrown) {
                    jQuery.confirm({
                        title: "Alert!",
                        content: errorThrown,
                        theme: 'modern',
                        buttons: {
                            ok: {
                                text: 'OK',
                                btnClass: 'add-button',
                                action: function () {
                                    return
                                }
                            }
                        }
                    });
                    jQuery("#tab3 .btn-txt").css("display", "block");
                    jQuery("#tab3 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn-per-hour").removeAttr('disabled');

                },
                complete: function () {
                    jQuery("#tab3 .btn-txt").css("display", "block");
                    jQuery("#tab3 .spinn").removeClass("add_custome_loader");
                    jQuery(".btn-per-hour").removeAttr('disabled');

                }
            });
        }
    });

});




function view_record(Id) {
    jQuery.ajax({
        "url": BMSI_object.ajax_url,
        "type": "POST",
        "data": {
            "action": "BMSI_view_user",
            "id": Id,
            "view_nonce": BMSI_object.nonce,
        },
        "success": function (response) {
            jQuery(".modal-body .id .user_id").text(response[0]['id']);
            jQuery(".modal-body .name .user_name").text(response[0]['uname']);
            jQuery(".modal-body .email .user_email").text(response[0]['email']);
            jQuery(".modal-body .mobile .user_mobile").text(response[0]['mobile_no']);
            jQuery(".modal-body .role .user_role").text(response[0]['role']);
        },
    });
}

function view_history(id) {
    jQuery.ajax({
        "url": BMSI_object.ajax_url,
        "type": "POST",
        "data": {
            "action": "BMSI_view_history",
            "id": id,
            "n_history_nonce": BMSI_object.nonce,
        },
        "success": function (response) {
            tinyMCE.get('bmsi_mail_box').setContent(response.body);
        },
    });
}