<?php

if (!defined('ABSPATH'))
    exit;
?>

<?php

include "BMSIHeader.php";

?>

<div class="col-lg-10">
    <div class="main">
        <?php
        // Output the nonce field in your form
        $nonce = wp_create_nonce('create_user_nonce');
        ?>

        <?php if (is_bulk_mail_pro_activated()) {
            if (get_option('BMIS_Pro_activated')) { ?>

                <form action="#" method="POST" class="form_data">
                    <div id="form_data">
                        <input type="hidden" id="create_user_nonce" name="create_user_nonce"
                            value="<?php echo esc_attr($nonce); ?>" />
                        <div class="pt-4"></div>
                        <div class="form-contant d-flex flex-column">
                            <div
                                class="add-new-users d-lg-flex d-md-flex d-sm-flex d-block justify-content-between flex-row align-items-center">
                                <div class="title">
                                    <h1 class="fw-bold" style="font-size: 40px;">Add New User</h1>
                                </div>
                                <div
                                    class="d-flex justify-content-lg-between justify-content-md-between justify-content-sm-between justify-content-start flex-row">
                                    <a class="add-button border-0 btn-back"
                                        href="<?php printf(esc_html('%sadmin.php?page=users', 'bulk-mail'), esc_html($admin_url)); ?>">Back</a>
                                    <button type="submit" name="submit-sub" id="submit"
                                        class="add-button fs-16menu border-0 btn_add_user btn-save"><span
                                            class="btn-txt">Save</span><i class="fa-solid fa-spinner spinn"></i></button>
                                </div>
                            </div>
                            <div class="firstAndLastName">
                                <div>
                                    <label for="fname">First Name</label>
                                    <input type="text" class="input-groups" name="fname" id="fname"
                                        placeholder="Enter User First Name" value="<?php if (!empty($user_names[0])) {
                                            printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->email));
                                        } ?>" required>
                                </div>
                                <div>
                                    <label for="lname" class="lname">Last Name</label>
                                    <input type="text" class="input-groups" name="lname" id="lname"
                                        placeholder="Enter User Last Name" value="<?php if (!empty($user_names[1])) {
                                            printf(esc_html__('%s.', 'bulk-mail'), esc_html($user_names[1]));
                                        } ?>" required>
                                </div>
                            </div>
                            <div class="firstAndLastName">
                                <div>
                                    <label for="email">Email</label>
                                    <input type="email" class="input-groups" name="email" id="email"
                                        placeholder="Enter User Email" value="<?php if (!empty($edit_data[0]->email)) {
                                            printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->email));
                                        } ?>" required>
                                </div>
                                <div>
                                    <label for="mob">Mobile No</label>
                                    <input type="number" class="input-groups" name="mob" id="mob"
                                        placeholder="Enter User Mobile Number" value="<?php if (!empty($edit_data[0]->mobile)) {
                                            printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->mobile));
                                        } ?>" required>
                                </div>
                            </div>

                            <div class="firstAndLastName">
                                <?php
                                $option = get_option("BMSI_User_Options");
                                if (!empty($option["pass"]) && $option["pass"] == "false") {
                                    ?>
                                    <div>

                                        <label for="pass">Password</label>
                                        <input type="text" class="input-groups" name="pass" id="pass"
                                            placeholder="Enter User Password" value="<?php if (!empty($edit_data[0]->pass)) {
                                                printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->pass));
                                            } ?>" required>
                                    </div>

                                <?php } ?>
                                <div>
                                    <label for="role">User Role</label>
                                    <?php
                                    global $wp_roles;
                                    $roles = $wp_roles->get_names();
                                    ?>
                                    <select name="role" id="role" class="input-groups">
                                        <?php
                                        foreach ($roles as $key => $role) { ?>
                                            <option name="roles" value="<?php echo esc_attr($key); ?>">
                                                <?php echo esc_attr($role); ?>
                                            </option>
                                        <?php } ?>
                                    </select>

                                </div>

                            </div>
                            <div class="align-items-end save-button">
                                <button type="submit" name="submit-sub" id="submit"
                                    class="add-button fs-16menu border-0 btn_add_user btn-save"><span
                                        class="btn-txt">Save</span><i class="fa-solid fa-spinner spinn"></i></button>
                            </div>
                        </div>
                    </div>
                </form>
            <?php } else { ?>
                <div class="creatuser-bg-image d-flex justify-content-center align-items-center">
                    <div class="dashboard-wrapper">
                        <div class="bg-color p-3 rounded-4 mx-5">
                            <svg xmlns="http://www.w3.org/2000/svg" width="55" height="55" viewBox="0 0 66 75" fill="none">
                                <path
                                    d="M58.8933 37.3734H22.9333V22.4884C22.9333 16.7711 27.5298 12.0212 33.2718 11.9635C39.0718 11.9057 43.8133 16.5979 43.8133 22.3584V24.6684C43.8133 26.5886 45.3648 28.1334 47.2933 28.1334H51.9333C53.8618 28.1334 55.4133 26.5886 55.4133 24.6684V22.3584C55.4133 10.231 45.4808 0.37016 33.3008 0.413472C21.1208 0.456785 11.3333 10.4475 11.3333 22.575V37.3734H7.85331C4.01081 37.3734 0.893311 40.4775 0.893311 44.3034V67.4033C0.893311 71.2293 4.01081 74.3333 7.85331 74.3333H58.8933C62.7358 74.3333 65.8533 71.2293 65.8533 67.4033V44.3034C65.8533 40.4775 62.7358 37.3734 58.8933 37.3734ZM39.1733 59.3184C39.1733 62.509 36.5778 65.0933 33.3733 65.0933C30.1688 65.0933 27.5733 62.509 27.5733 59.3184V52.3884C27.5733 49.1977 30.1688 46.6134 33.3733 46.6134C36.5778 46.6134 39.1733 49.1977 39.1733 52.3884V59.3184Z"
                                    fill="white" />
                            </svg>
                        </div>
                        <div class="text-center mt-2">
                            <p style="margin-bottom:0;">Activate Pro version</p>
                            <a
                                href="<?php printf(esc_html('%sadmin.php?page=settings', 'bulk-mail-sender-pro'), esc_html($admin_url)); ?>">click
                                here</a>
                        </div>
                    </div>
                </div>
            <?php }
        } else { ?>

            <form action="#" method="POST" class="form_data">
                <div id="form_data">
                    <input type="hidden" id="create_user_nonce" name="create_user_nonce"
                        value="<?php echo esc_attr($nonce); ?>" />
                    <div class="pt-4"></div>
                    <div class="form-contant d-flex flex-column">
                        <div
                            class="add-new-users d-lg-flex d-md-flex d-sm-flex d-block justify-content-between flex-row align-items-center">
                            <div class="title">
                                <h1 class="fw-bold" style="font-size: 40px;">Add New User</h1>
                            </div>
                            <div
                                class="d-flex justify-content-lg-between justify-content-md-between justify-content-sm-between justify-content-start flex-row">
                                <a class="add-button border-0 btn-back"
                                    href="<?php printf(esc_html('%sadmin.php?page=users', 'bulk-mail'), esc_html($admin_url)); ?>">Back</a>
                                <button type="submit" name="submit-sub" id="submit"
                                    class="add-button fs-16menu border-0 btn_add_user btn-save"><span
                                        class="btn-txt">Save</span><i class="fa-solid fa-spinner spinn"></i></button>
                            </div>
                        </div>
                        <div class="firstAndLastName">
                            <div>
                                <label for="fname">First Name</label>
                                <input type="text" class="input-groups" name="fname" id="fname"
                                    placeholder="Enter User First Name" value="<?php if (!empty($user_names[0])) {
                                        printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->email));
                                    } ?>" required>
                            </div>
                            <div>
                                <label for="lname" class="lname">Last Name</label>
                                <input type="text" class="input-groups" name="lname" id="lname"
                                    placeholder="Enter User Last Name" value="<?php if (!empty($user_names[1])) {
                                        printf(esc_html__('%s.', 'bulk-mail'), esc_html($user_names[1]));
                                    } ?>" required>
                            </div>
                        </div>
                        <div class="firstAndLastName">
                            <div>
                                <label for="email">Email</label>
                                <input type="email" class="input-groups" name="email" id="email"
                                    placeholder="Enter User Email" value="<?php if (!empty($edit_data[0]->email)) {
                                        printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->email));
                                    } ?>" required>
                            </div>
                            <div>
                                <label for="mob">Mobile No</label>
                                <input type="number" class="input-groups" name="mob" id="mob"
                                    placeholder="Enter User Mobile Number" value="<?php if (!empty($edit_data[0]->mobile)) {
                                        printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->mobile));
                                    } ?>" required>
                            </div>
                        </div>

                        <div class="firstAndLastName">
                            <?php
                            $option = get_option("BMSI_User_Options");
                            if (!empty($option["pass"]) && $option["pass"] == "false") {
                                ?>
                                <div>

                                    <label for="pass">Password</label>
                                    <input type="text" class="input-groups" name="pass" id="pass"
                                        placeholder="Enter User Password" value="<?php if (!empty($edit_data[0]->pass)) {
                                            printf(esc_html__('%s.', 'bulk-mail'), esc_html($edit_data[0]->pass));
                                        } ?>" required>
                                </div>

                            <?php } ?>
                            <div>
                                <label for="role">User Role</label>
                                <?php
                                global $wp_roles;
                                $roles = $wp_roles->get_names();
                                ?>
                                <select name="role" id="role" class="input-groups">
                                    <?php
                                    foreach ($roles as $key => $role) { ?>
                                        <option name="roles" value="<?php echo esc_attr($key); ?>">
                                            <?php echo esc_attr($role); ?>
                                        </option>
                                    <?php } ?>
                                </select>

                            </div>

                        </div>
                        <div class="align-items-end save-button">
                            <button type="submit" name="submit-sub" id="submit"
                                class="add-button fs-16menu border-0 btn_add_user btn-save"><span
                                    class="btn-txt">Save</span><i class="fa-solid fa-spinner spinn"></i></button>
                        </div>
                    </div>
                </div>
            </form>
        <?php } ?>
    </div>
</div>

<?php include "BMSIFooter.php"; ?>

</body>

</html>